js_timer_func = [[
<script type="text/javascript">
function local_timer_func()
{
    document.call_setting.submit();
}
function local_onload_func()
{
    timer=setTimeout('local_timer_func()',5000);
}
</script>
]]
js_timer_func2 = [[
<script type="text/javascript">
function local_onload_func()
{
}
</script>
]]

disabled_text = function (expr)
  if (expr) then
    return ' disabled '
  else
    return ''
  end
end

show_section = function (prefix, all_enab,busy_enab,reach_enab,noreply_enab,all_number,busy_number,reach_number,noreply_number,time_val)
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_all_enab_hidden" value="'..all_enab..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_busy_enab_hidden" value="'..busy_enab..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_reach_enab_hidden" value="'..reach_enab..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_noreply_enab_hidden" value="'..noreply_enab..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_all_number_hidden" value="'..all_number..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_busy_number_hidden" value="'..busy_number..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_reach_number_hidden" value="'..reach_number..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_noreply_number_hidden" value="'..noreply_number..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_time_hidden" value="'..time_val..'">')
    
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("forward all")..'&nbsp;</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_all_enab" value="on" '..checked_text(all_enab == 1)..'>&nbsp;' ..current_dictionary("enabled")..'</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="text" name="'..prefix..'_all_number" maxlength="32" size="32" value="'..all_number..'" </p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("forward busy")..'&nbsp;</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_busy_enab" value="on" '..checked_text(busy_enab == 1)..'>&nbsp;' ..current_dictionary("enabled")..'</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="text" name="'..prefix..'_busy_number" maxlength="32" size="32" value="'..busy_number..'" </p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("forward not reachable")..'&nbsp;</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_reach_enab"  value="on" '..checked_text(reach_enab == 1)..'>&nbsp;' ..current_dictionary("enabled")..'&nbsp;&nbsp;</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="text" name="'..prefix..'_reach_number" maxlength="32" size="32" value="'..reach_number..'" </p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("forward no reply")..'&nbsp;</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_noreply_enab" value="on" '..checked_text(noreply_enab == 1)..'>&nbsp;' ..current_dictionary("enabled")..'</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="text" name="'..prefix..'_noreply_number" maxlength="32" size="32" value="'..noreply_number..'" </p></td>')
        put('<td align="left"><p>&nbsp;'..current_dictionary("unanswered")..'&nbsp;')
        put('<select ' .. disabled_string .. '  name="'..prefix..'_time">')
        put(' <option value=5' .. option_text(time_val == 5) .. '> 5 '..current_dictionary("seconds_3letter")..'</option>')
        put(' <option value=10' .. option_text(time_val == 10) .. '> 10 '..current_dictionary("seconds_3letter")..'</option>')
        put(' <option value=15' .. option_text(time_val == 15) .. '> 15 '..current_dictionary("seconds_3letter")..'</option>')
        put(' <option value=20' .. option_text(time_val == 20) .. '> 20 '..current_dictionary("seconds_3letter")..'</option>')
        put(' <option value=25' .. option_text(time_val == 25) .. '> 25 '..current_dictionary("seconds_3letter")..'</option>')
        put(' <option value=30' .. option_text(time_val == 30) .. '> 30 '..current_dictionary("seconds_3letter")..'</option>')
        put('</select></p></td>\n')
    put('</tr>')
end

validate_post_values = function(arg)
    msg = nil
    if_class = 1
    if arg == "speech" then
        if_class = 1
    elseif arg == "audio" then
        if_class = 4
    elseif arg == "data" then
        if_class = 2
    end

    -- forward all
    if cgilua.cgi[arg.."_all_number"] ~= nil and string.gsub(cgilua.cgi[arg.."_all_number"],"[+*# ]","") ~= "" then
        if not check_number(cgilua.cgi[arg.."_all_number"]) then
            msg = current_dictionary("only 0-9, +, *, # and spaces are allowed in phone numbers")
        end
    end

    -- forward busy
    if cgilua.cgi[arg.."_busy_number"] ~= nil and string.gsub(cgilua.cgi[arg.."_busy_number"],"[+*# ]","") ~= "" then
        if not check_number(cgilua.cgi[arg.."_busy_number"]) then
            msg = current_dictionary("only 0-9, +, *, # and spaces are allowed in phone numbers")
        end
    end

    -- forward out of reach
    if cgilua.cgi[arg.."_reach_number"] ~= nil and string.gsub(cgilua.cgi[arg.."_reach_number"],"[+*# ]","") ~= ""then
        if not check_number(cgilua.cgi[arg.."_reach_number"]) then
            msg = current_dictionary("only 0-9, +, *, # and spaces are allowed in phone numbers")
        end
    end

    -- forward no reply
    if cgilua.cgi[arg.."_noreply_number"] ~= nil and string.gsub(cgilua.cgi[arg.."_noreply_number"],"[+*# ]","") ~= "" then
        if not check_number(cgilua.cgi[arg.."_noreply_number"]) then
            msg = current_dictionary("only 0-9, +, *, # and spaces are allowed in phone numbers")
        end
    end
    if msg ~= nil then
        error_msg = msg
        return false
    else
        return true
    end
end

handle_post_values = function(arg)
    if_class = 1
    if arg == "speech" then
        if_class = 1
    elseif arg == "audio" then
        if_class = 4
    elseif arg == "data" then
        if_class = 2
    end

    -- forward all
    if cgilua.cgi[arg.."_all_enab"] ~= nil then
        if cgilua.cgi[arg.."_all_enab"] == "on" then
            vals[arg..'_all_enab'] = 1
        else
            vals[arg..'_all_enab'] = 0
        end        
    end
    if cgilua.cgi[arg.."_all_number"] ~= nil and string.gsub(cgilua.cgi[arg.."_all_number"],"[+*# ]","") ~= "" then
        vals[arg..'_all_number'] = cgilua.cgi[arg.."_all_number"]
    end
    if cgilua.cgi[arg..'_all_enab_hidden'] ~= nil then
        if vals[arg..'_all_enab'] ~= tonumber(cgilua.cgi[arg..'_all_enab_hidden']) or
            vals[arg..'_all_number'] ~= cgilua.cgi[arg..'_all_number_hidden'] then
            ss_if.change_cf(1,if_class,vals[arg..'_all_enab'], strip_spaces(vals[arg..'_all_number']),0,
                            vals[arg.."_all_enab"] ~= tonumber(cgilua.cgi[arg.."_all_enab_hidden"]), 
                            vals[arg.."_all_number"] ~= cgilua.cgi[arg.."_all_number_hidden"],false)
           
        end
    end

    -- forward busy
    if cgilua.cgi[arg.."_busy_enab"] ~= nil then
        if cgilua.cgi[arg.."_busy_enab"] == "on" then
            vals[arg..'_busy_enab'] = 1
        else
            vals[arg..'_busy_enab'] = 0
        end        
    end
    if cgilua.cgi[arg.."_busy_number"] ~= nil and string.gsub(cgilua.cgi[arg.."_busy_number"],"[+*# ]","") ~= "" then
        vals[arg..'_busy_number'] = cgilua.cgi[arg.."_busy_number"]
    end
    if cgilua.cgi[arg..'_busy_enab_hidden'] ~= nil then
        if vals[arg..'_busy_enab'] ~= tonumber(cgilua.cgi[arg..'_busy_enab_hidden']) or
            vals[arg..'_busy_number'] ~= cgilua.cgi[arg..'_busy_number_hidden'] then
            ss_if.change_cf(2,if_class,vals[arg..'_busy_enab'], strip_spaces(vals[arg..'_busy_number']),0,
                                vals[arg.."_busy_enab"] ~= tonumber(cgilua.cgi[arg.."_busy_enab_hidden"]),
                                vals[arg.."_busy_number"] ~= cgilua.cgi[arg.."_busy_number_hidden"],false)
        end
    end

    -- forward out of reach
    if cgilua.cgi[arg.."_reach_enab"] ~= nil then
        if cgilua.cgi[arg.."_reach_enab"] == "on" then
            vals[arg..'_reach_enab'] = 1
        else
            vals[arg..'_reach_enab'] = 0
        end        
    end
    if cgilua.cgi[arg.."_reach_number"] ~= nil and string.gsub(cgilua.cgi[arg.."_reach_number"],"[+*# ]","") ~= ""then
        vals[arg..'_reach_number'] = cgilua.cgi[arg.."_reach_number"]
    end
    if cgilua.cgi[arg..'_reach_enab_hidden'] ~= nil then
        if vals[arg..'_reach_enab'] ~= tonumber(cgilua.cgi[arg..'_reach_enab_hidden']) or
            vals[arg..'_reach_number'] ~= cgilua.cgi[arg..'_reach_number_hidden'] then
            ss_if.change_cf(3,if_class,vals[arg..'_reach_enab'], strip_spaces(vals[arg..'_reach_number']),0,
                                vals[arg.."_reach_enab"] ~= tonumber(cgilua.cgi[arg.."_reach_enab_hidden"]),
                                vals[arg.."_reach_number"] ~= cgilua.cgi[arg.."_reach_number_hidden"],false)
        end
    end

    -- forward no reply
    if cgilua.cgi[arg.."_noreply_enab"] ~= nil then
        if cgilua.cgi[arg.."_noreply_enab"] == "on" then
            vals[arg..'_noreply_enab'] = 1
        else
            vals[arg..'_noreply_enab'] = 0
        end        
    end
    if cgilua.cgi[arg.."_noreply_number"] ~= nil and string.gsub(cgilua.cgi[arg.."_noreply_number"],"[+*# ]","") ~= "" then
        vals[arg..'_noreply_number'] = cgilua.cgi[arg.."_noreply_number"]
    end
    if cgilua.cgi[arg.."_time"] ~= nil then
        vals[arg..'_time_val'] = tonumber(cgilua.cgi[arg.."_time"])
    end
    if cgilua.cgi[arg..'_noreply_enab_hidden'] ~= nil then
        if vals[arg..'_noreply_enab'] ~= tonumber(cgilua.cgi[arg..'_noreply_enab_hidden']) or
            vals[arg..'_noreply_number'] ~= cgilua.cgi[arg..'_noreply_number_hidden'] or 
            vals[arg..'_time_val'] ~= tonumber(cgilua.cgi[arg..'_time_hidden']) then
            ss_if.change_cf(4,if_class,vals[arg..'_noreply_enab'], strip_spaces(vals[arg..'_noreply_number']),
                                vals[arg.."_time_val"],
                                vals[arg.."_noreply_enab"] ~= tonumber(cgilua.cgi[arg.."_noreply_enab_hidden"]), 
                                vals[arg.."_noreply_number"] ~= cgilua.cgi[arg.."_noreply_number_hidden"],
                                vals[arg.."_time_val"] ~= tonumber(cgilua.cgi[arg.."_time_hidden"]))
        end
    end
end

init_with_hidden_values = function(arg)
    -- forward all
    if cgilua.cgi[arg.."_all_enab_hidden"] ~= nil then
        vals[arg..'_all_enab'] = tonumber(cgilua.cgi[arg.."_all_enab_hidden"])
    end
    if cgilua.cgi[arg.."_all_number_hidden"] ~= nil then
        vals[arg..'_all_number'] = cgilua.cgi[arg.."_all_number_hidden"]
    end

    -- forward busy
    if cgilua.cgi[arg.."_busy_enab_hidden"] ~= nil then
        vals[arg..'_busy_enab'] = tonumber(cgilua.cgi[arg.."_busy_enab_hidden"])
    end
    if cgilua.cgi[arg.."_busy_number_hidden"] ~= nil then
        vals[arg..'_busy_number'] = cgilua.cgi[arg.."_busy_number_hidden"]
    end

    -- forward out of reach
    if cgilua.cgi[arg.."_reach_enab_hidden"] ~= nil then
        vals[arg..'_reach_enab'] = tonumber(cgilua.cgi[arg.."_reach_enab_hidden"])
    end
    if cgilua.cgi[arg.."_reach_number_hidden"] ~= nil then
        vals[arg..'_reach_number'] = cgilua.cgi[arg.."_reach_number_hidden"]
    end

    -- forward no reply
    if cgilua.cgi[arg.."_noreply_enab_hidden"] ~= nil then
        vals[arg..'_noreply_enab'] = tonumber(cgilua.cgi[arg.."_noreply_enab_hidden"])
    end
    if cgilua.cgi[arg.."_noreply_number_hidden"] ~= nil then
        vals[arg..'_noreply_number'] = cgilua.cgi[arg.."_noreply_number_hidden"]
    end
    if cgilua.cgi[arg.."_time_hidden"] ~= nil then
        vals[arg..'_time_val'] = tonumber(cgilua.cgi[arg.."_time_hidden"])
    end
end

-- Setup initial values
vals = {}
vals["speech_all_number"] = ""
vals["speech_busy_number"] = ""
vals["speech_reach_number"] = ""
vals["speech_noreply_number"] = ""
vals["speech_time_val"] = 20
vals["speech_all_enab"] = 0
vals["speech_busy_enab"] = 0
vals["speech_reach_enab"] = 0
vals["speech_noreply_enab"] = 0

vals["audio_all_number"] = ""
vals["audio_busy_number"] = ""
vals["audio_reach_number"] = ""
vals["audio_noreply_number"] = ""
vals["audio_time_val"] = 20
vals["audio_all_enab"] = 0
vals["audio_busy_enab"] = 0
vals["audio_reach_enab"] = 0
vals["audio_noreply_enab"] = 0

vals["data_all_number"] = ""
vals["data_busy_number"] = ""
vals["data_reach_number"] = ""
vals["data_noreply_number"] = ""
vals["data_time_val"] = 20
vals["data_all_enab"] = 0
vals["data_busy_enab"] = 0
vals["data_reach_enab"] = 0
vals["data_noreply_enab"] = 0

valid_data = true
if cgilua.cgi["cf_query"] ~= nil then
    ss_if.query_call_forward_status(1)
    ss_if.query_call_forward_status(2)
    ss_if.query_call_forward_status(3)
    ss_if.query_call_forward_status(4)
    
elseif cgilua.cgi["cf_apply"] ~= nil then
    -- Parse incomming parameters
    if validate_post_values("speech") and validate_post_values("audio") and validate_post_values("data") then
        handle_post_values("speech")
        handle_post_values("audio")
        handle_post_values("data")
    else
        init_with_hidden_values("speech")
        init_with_hidden_values("audio")
        init_with_hidden_values("data")
        valid_data = false
    end    
else
    init_with_hidden_values("speech")
    init_with_hidden_values("audio")
    init_with_hidden_values("data")
end    

if cgilua.cgi["cf_query"] ~= nil then 
    trace(0,1,"cf_query")
end
if cgilua.cgi["cf_apply"] ~= nil then 
    trace(0,1,"cf_apply")
end


wait = false
if ss_if.is_operation_in_progress() then
    error_msg = current_dictionary("operation in progress")
    wait = true
end

number_cf_records = 0
if wait == false then
    -- If hidden values exist (not first time we show the page), show warning if last operation might have failed.
    if cgilua.cgi["speech_all_enab_hidden"] ~= nil then
        cf_res, number_cf_records = ss_if.get_last_cf_operation_result()
        if not cf_res then
            if cgilua.cgi["cfop"] == "query" then
                error_msg = current_dictionary("cf query failed")
            elseif cgilua.cgi["cfop"] == "set" and valid_data == true then
                -- only set error_msg if we don't have previous error_msg from e.g. number check in handle_post_values
                error_msg = current_dictionary("cf set failed") 
            end
        end
        if cf_res then
            trace(0,1, string.format("CF result ok"))
        else
            trace(0,1, string.format("CF result fail"))
        end
        if cf_res == nil then
            trace(0,1, string.format("CF result NIL"))
        end

        -- get values from ss_if first time after query is done
        if cgilua.cgi["cfop"] == "query" then
            if number_cf_records ~= nil then
                trace(0,1, string.format("records %d",number_cf_records))
            else
                trace(0,1, string.format("records nil"))
            end
        
            if number_cf_records > 0 then
                for i=1,number_cf_records do
                    cf_enab, cf_class, cf_time, cf_ss_type, cf_type, cf_number = ss_if.get_cf_entry(i-1)
--                    put('<br>idx '..tostring(i))
--                    put(' enab '..tostring(cf_enab))
--                    put(' class '..tostring(cf_class))
--                    put(' time '..tostring(cf_time))
--                    put(' ss_type '..tostring(cf_ss_type))
--                    put(' type '..tostring(cf_type))
--                    put(' number '..tostring(cf_number))
                    if cf_enab then
                        class_txt = nil
                        if cf_class == 1 then
                            class_txt = "speech"
                        elseif cf_class == 2 then
                            class_txt = "data"
                        elseif cf_class == 4 then
                            class_txt = "audio"
                        end
                        type_txt = nil
                        if cf_ss_type == 1 then
                            type_txt = "_all"
                        elseif cf_ss_type == 2 then
                            type_txt = "_busy"
                        elseif cf_ss_type == 3 then
                            type_txt = "_reach"
                        elseif cf_ss_type == 4 then
                            type_txt = "_noreply"
                        end
                        if class_txt ~= nil and type_txt ~= nil then
                            vals[class_txt..type_txt.."_enab"] = cf_enab
                            if cf_type == 145 then
                                vals[class_txt..type_txt.."_number"] = "+"..cf_number
                            else
                                vals[class_txt..type_txt.."_number"] = cf_number
                            end
                            if cf_ss_type == 4 then
                                vals[class_txt.."_time_val"] = cf_time
                            end
                        else
                            trace(0,1,string.format("Invalid class or type in response"))
                        end
                    end
                end
            end
        end
    else
        if not msg_if.lua_is_ready_for_ss() then
            error_msg = current_dictionary("ss reg needed")
        end
    end
end

if cgilua.cgi["local_onload"] ~= nil then
    trace(0,1,"cf onload")
end

-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_supplementary")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end

put(start_of_content)

put('<p id="errortext">' .. error_msg .. '</p>')

if wait then
    put(js_timer_func)
elseif cgilua.cgi["local_onload"] ~= nil then
    put(js_timer_func2)
elseif cgilua.cgi["cf_apply"] ~= nil and valid_data == false then  
    -- handle the case of input check failed after apply and we haven't started any operation
    -- should be removed when error checking is converted to be handled by javascript on submit
    put(js_timer_func2)
end
put('<p><table align="left" border="'..border_on..'" cellpadding="0">\n')
put('<form name="call_setting" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
--put('<tr><td colspan="4"><p id="errortext">'..error_msg..'</p></td></tr>')
put('<tr><td align="left" colspan="2"><p>'..current_dictionary("read values")..'&nbsp;&nbsp;<input ' .. disabled_string .. ' type="submit" name="cf_query" value="'..current_dictionary("read button")..'" '..disabled_text(wait)..'></p></td>')
put('<tr><td>&nbsp;</td></tr>')
if cgilua.cgi["cf_query"] ~= nil then
    put('<input ' .. disabled_string .. ' type="hidden" name="cfop" value="query">')
elseif cgilua.cgi["cf_apply"] ~= nil then
    put('<input ' .. disabled_string .. ' type="hidden" name="cfop" value="set">')
elseif wait and cgilua.cgi["cfop"] ~= nil then
    put('<input ' .. disabled_string .. ' type="hidden" name="cfop" value="'..cgilua.cgi["cfop"]..'">')
end
if wait then
    put('<input ' .. disabled_string .. ' type="hidden" name="local_onload" value="">')
end

put('<tr>')
    put('<th align="left" colspan="2"><p class="menutext">' ..current_dictionary("standard voice").. '</p></th>')
put('</tr>')

show_section("speech",vals["speech_all_enab"],vals["speech_busy_enab"],vals["speech_reach_enab"],vals["speech_noreply_enab"],
                vals["speech_all_number"],vals["speech_busy_number"],vals["speech_reach_number"],vals["speech_noreply_number"],vals["speech_time_val"])

put('<tr>')
    put('<th align="left"><p class="menutext">' ..current_dictionary("3.1kHz audio").. '</p></th>')
put('</tr>')

show_section("audio",vals["audio_all_enab"],vals["audio_busy_enab"],vals["audio_reach_enab"],vals["audio_noreply_enab"],
                vals["audio_all_number"],vals["audio_busy_number"],vals["audio_reach_number"],vals["audio_noreply_number"],vals["audio_time_val"])

put('<tr>')
    if hasISDN == TT_TRUE then
        put('<th align="left"><p class="menutext">' ..current_dictionary("data isdn").. '</p></th>')
    else
        put('<th align="left"><p class="menutext">' ..current_dictionary("data").. '</p></th>')
    end
put('</tr>')

show_section("data",vals["data_all_enab"],vals["data_busy_enab"],vals["data_reach_enab"],vals["data_noreply_enab"],
                vals["data_all_number"],vals["data_busy_number"],vals["data_reach_number"],vals["data_noreply_number"],vals["data_time_val"])

put('<tr>')
put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="submit" value="'..current_dictionary("apply")..'" name="cf_apply" '..disabled_text(wait)..'>&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="reset" value="'..current_dictionary("cancel")..'" name="reset" '..disabled_text(wait)..'></p></td>')
put('</tr>')
put('<tr><td>&nbsp;</td></tr>')
put('<tr>')
    put('<td align="left" colspan="4">')
        put('<p>' ..current_dictionary("ss info").. '</p>')
    put('</td>')
put('</tr>')


put('</form>\n') 
put('</table></p>\n')
put(end_of_content)

