
--printResult = ""

--function cgi_trace (...)
--    for i,v in ipairs(arg) do
--        printResult = printResult .. tostring(v) .. "\t"
--    end
--    trace(0, 1, printResult)
--end

--table.foreach(cgilua.cgi,cgi_trace)


error_msg = ""

show_section = function (index, activate_enab, group_number)
    put('<tr>')
        put('<td align="left"><p>' .. index .. '</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="activate_enab" value="' .. index ..'" '..checked_text(activate_enab)..'></p></td>')
        if group_number ~= "subscribed" then
            put('<td align="left"><p><input ' .. disabled_string .. ' type="text" name="'..index..'_group_number" maxlength="32" size="32" value="'..group_number..'" </p></td>')
        else
            put('<td align="left"><p>' .. current_dictionary("subscribed") .. '</p></td>')
        end 
        
        put('</tr>')
end

-- Setup initial values before store
ino0, idef0, ino1, idef1, ino2, idef2, ino3, idef3, ino4, idef4, ino5, idef5, ino6, idef6, ino7, idef7, ino8, idef8, ino9, idef9, oa, pref, active_index = msg_if.lua_get_cug_status()
--oa, pref, active_index = msg_if.lua_get_cug_status()
ino = {ino0, ino1, ino2, ino3, ino4, ino5, ino6, ino7, ino8, ino9}
idef = {idef0, idef1, idef2, idef3, idef4, idef5, idef6, idef7, idef8, idef9}

for i = 1,table.getn(ino) do
    trace(0, 1, string.format("lua - index no: %d", ino[i]))
    trace(0, 1, string.format("lua - index def: %d", idef[i]))
end
trace(0, 1, string.format("lua - oa: %d", oa))
trace(0, 1, string.format("lua - pref: %d", pref))
trace(0, 1, string.format("lua - active_index: %d", active_index))

--store values
store = "false"
if cgilua.cgi["oa_enab"] ~= nil and cgilua.cgi["oa_enab"] == "on" then
    trace(0, 1, "store oa on")
    oa = TT_TRUE
    trace(0, 1, string.format("lua - value: %d", oa))
    store = "true"
else
    if oa ~= TT_FALSE then
        trace(0, 1, "store change oa")
        oa = TT_FALSE
        trace(0, 1, string.format("lua - value: %d", oa))
        store = "true"
    end
end
if cgilua.cgi["pref_enab"] ~= nil and cgilua.cgi["pref_enab"] == "on" then
    trace(0, 1, "store pref on")
    pref = TT_TRUE
    trace(0, 1, string.format("lua - value: %d", pref))
    store = "true"
    else
    if pref ~= TT_FALSE then
        trace(0, 1, "store change pref")
        pref = TT_FALSE
        trace(0, 1, string.format("lua - value: %d", pref))
        store = "true"
    end
end
if cgilua.cgi["activate_enab"] ~= nil then
    trace(0, 1, string.format("active index: %d", tonumber(cgilua.cgi["activate_enab"])))
    active_index = tonumber(cgilua.cgi["activate_enab"])
    store = "true"
end
for i = 1,table.getn(ino) do
    if cgilua.cgi[i-1 .. "_group_number"] ~= nil then
        if tonumber(cgilua.cgi[i-1 .. "_group_number"]) == 0 then
            msg_if.lua_undefine_cug(i-1)
        else
            msg_if.lua_define_cug(i-1,tonumber(cgilua.cgi[i-1 .. "_group_number"]))            
        end
    end
end
if store == "true" then
    msg_if.lua_activate_cug(oa,pref,active_index)
end


-- Setup initial values again after store
ino0, idef0, ino1, idef1, ino2, idef2, ino3, idef3, ino4, idef4, ino5, idef5, ino6, idef6, ino7, idef7, ino8, idef8, ino9, idef9, oa, pref, active_index = msg_if.lua_get_cug_status()
--oa, pref, active_index = msg_if.lua_get_cug_status()
ino = {ino0, ino1, ino2, ino3, ino4, ino5, ino6, ino7, ino8, ino9}
idef = {idef0, idef1, idef2, idef3, idef4, idef5, idef6, idef7, idef8, idef9}

for i = 1,table.getn(ino) do
    trace(0, 1, string.format("lua - index no: %d", ino[i]))
    trace(0, 1, string.format("lua - index def: %d", idef[i]))
end
trace(0, 1, string.format("lua - oa: %d", oa))
trace(0, 1, string.format("lua - pref: %d", pref))
trace(0, 1, string.format("lua - active_index: %d", active_index))

-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_supplementary")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end

put(start_of_content)
put('<p id="errortext">' .. error_msg .. '</p>')
put('<p><table align="left" border="'..border_on..'" cellpadding="0">\n')
put('<form name="call_setting" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')

put('<tr>')
    put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("groups").. '&nbsp;&nbsp;</p></th>')
put('</tr>')

put('<tr>')
    put('<th align="left"><p>' ..current_dictionary("group index").. '&nbsp;&nbsp;</p></th><th align="left"><p>' ..current_dictionary("active").. '&nbsp;&nbsp;</p></th><th align="left"><p>' ..current_dictionary("group no").. '&nbsp;&nbsp;</p></th>')
put('</tr>')

for i = 1,table.getn(ino) do
    if i-1 == active_index then
        if tonumber(idef[i]) == 1 then
            trace(0, 1, string.format("lua - show index: %d", i))
            show_section(i-1,true,ino[i])
        else
            show_section(i-1,true,0)
        end
    else
        if tonumber(idef[i]) == 1 then
            trace(0, 1, string.format("lua - show index: %d", i))
            show_section(i-1,false,ino[i])
        else
            show_section(i-1,false,0)
        end
    end
end        

if active_index == 10 then
    show_section(10,true,"subscribed")
else
    show_section(10,false,"subscribed")
end

put('<tr>')
    put('<th align="left" colspan="3"><p class="menutext">' ..current_dictionary("cug settings").. '&nbsp;&nbsp;</p></th>')
put('</tr>')

if active_index == 10 then
    put('<tr>')
        put('<td align="left"  colspan="3"><p id="errortext">' .. current_dictionary("subscribed error") .. '</p></td>')
    put('</tr>') 
end

put('<tr>')
    put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="oa_enab" value="on" '..checked_text(oa == 1)..'>&nbsp;'..current_dictionary("outgoing access")..'&nbsp;&nbsp;</p></td>')
    put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="pref_enab" value="on" '..checked_text(pref == 1)..'>&nbsp;' ..current_dictionary("preferential")..'</p></td>')
put('</tr>')

put('<tr>')
put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="submit" value="'..current_dictionary("apply")..'" name="cug_apply">&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="reset" value="'..current_dictionary("cancel")..'" name="reset"></p></td>')
put('</tr>')

put('</form>\n') 
put('</table></p>\n')
put(end_of_content)

