--parse input
if cgilua.cgi["extsys"] ~= nil and cgilua.cgi["extsys"] ~= "" then
    sp1 = 1
    sp2 = 1
    en1 = 0
    en2 = 0
    if cgilua.cgi["prim_speed"] ~= nil then
        sp1 = tonumber(cgilua.cgi["prim_speed"])
    end
    if cgilua.cgi["sec_speed"] ~= nil then
        sp2 = tonumber(cgilua.cgi["sec_speed"])
    end
    if cgilua.cgi["prim_enab"] ~= nil then
        en1 = tonumber(cgilua.cgi["prim_enab"])
    end
    if cgilua.cgi["sec_enab"] ~= nil then
        en2 = tonumber(cgilua.cgi["sec_enab"])
    end
    
    result = msg_if.lua_aero_set_extsystem(tonumber(cgilua.cgi["extsys"]),
                        sp1, sp2, en1, en2)

    if result == 2 then
        error_msg = current_dictionary("failed write protection")
    end
end

-- check write protection
disabled_string = ''
allowed = true
if msg_if.lua_is_aero_cm_write_protected() then
    allowed = false
    disabled_string = ' disabled '
    if error_msg == "" then
        -- don't overwrite message from submit
        error_msg = current_dictionary("write protected page")
    end
end

nav, prim_enab, sec_enab, prim_speed, sec_speed  = msg_if.lua_aero_get_extsystem()

put(start_of_content)

put('<p id="errortext">' .. error_msg .. '</p>\n')
put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '">\n')

put('<table align="left" border="' .. border_on ..'" cellpadding="0">\n')
put('<tr>')
put('<td colspan="2" align="left"><p class="menutext">' .. current_dictionary('navigational input') .. '</p></td>')
put('</tr>\n')

put('<tr>')
put('<td align="left"><p>'..current_dictionary('navigational input')..'&nbsp;&nbsp;</p></td>')
put('<td align="left"><p><select '..disabled_string..'name="extsys">')
    put('<option value="0" '..selected_text(nav ~= 1 and nav ~= 2 and nav ~= 3)..'> </option>')
    put('<option value="2" '..selected_text(nav == 2)..'>IRS</option>')
    put('<option value="1" '..selected_text(nav == 1)..'>AHRS</option>')
    put('<option value="3" '..selected_text(nav == 3)..'>NRS</option>')
put('</select></p></td>')
put('</tr>')

put('<tr>')
put('<td colspan="2" align="left"><p class="menutext">' .. current_dictionary("primary") .. '</p></td>')
put('</tr>')
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("arinc connected")..'</p></td>')
    put('<td align="left"><p><input '..disabled_string..' type="radio" name="prim_enab" value="1"')
    put(checked_text(prim_enab == 1)..'>'..current_dictionary("yes"))
    put('<input ' .. disabled_string .. ' type="radio" name="prim_enab" value="0"')
    put(checked_text(prim_enab ~= 1) ..'>' .. current_dictionary("no") .. '</p></td>')
put('</tr>\n')
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("arinc speed")..'</p></td>')
    put('<td align="left"><p><input '..disabled_string..' type="radio" name="prim_speed" value="1"')
    put(checked_text(prim_speed == 1)..'>'..current_dictionary("high speed"))
    put('<input ' .. disabled_string .. ' type="radio" name="prim_speed" value="0"')
    put(checked_text(prim_speed ~= 1) ..'>' .. current_dictionary("low speed") .. '</p></td>')
put('</tr>\n')

put('<tr>')
put('<td colspan="2" align="left"><p class="menutext">' .. current_dictionary("secondary") .. '</p></td>')
put('</tr>')
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("arinc connected")..'</p></td>')
    put('<td align="left"><p><input '..disabled_string..' type="radio" name="sec_enab" value="1"')
    put(checked_text(sec_enab == 1)..'>'..current_dictionary("yes"))
    put('<input ' .. disabled_string .. ' type="radio" name="sec_enab" value="0"')
    put(checked_text(sec_enab ~= 1) ..'>' .. current_dictionary("no") .. '</p></td>')
put('</tr>\n')
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("arinc speed")..'</p></td>')
    put('<td align="left"><p><input '..disabled_string..' type="radio" name="sec_speed" value="1"')
    put(checked_text(sec_speed == 1)..'>'..current_dictionary("high speed"))
    put('<input ' .. disabled_string .. ' type="radio" name="sec_speed" value="0"')
    put(checked_text(sec_speed ~= 1) ..'>' .. current_dictionary("low speed") .. '</p></td>')
put('</tr>\n')

--put('<tr>')
--	put('<td align="left" colspan="2"><p class="menutext">' ..current_dictionary("gps voltage") .. '</p></td>')
--put('</tr>\n')
--
--put('<tr>')
--put('<td align="left"><p>'..current_dictionary("gps voltage") .. '</p></td>')
--put('<td align="left"><p>')
--    put('<input ' .. disabled_string .. ' type="radio" name="radio_gps_voltage" value="0" '..checked_text(gps==1)..'>' .. current_dictionary('0vdc'))
--    put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="radio" name="radio_gps_voltage" value="5" '..checked_text(gps==2)..'>' .. current_dictionary('5vdc'))
--    put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="radio" name="radio_gps_voltage" value="12" '..checked_text(gps==3)..'>' .. current_dictionary('12vdc'))
--put('</p></td>')
--put('</tr>')

--Submit/Cancel buttons

put('<tr>')
put('<td align="left" colspan="4"><p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>')
put('</tr>\n')
put('</table>\n\n')

put('</form>\n')

put(end_of_content)
 

