
function set_dictionary (set_lang)
    if set_lang == "english" then
        require(set_lang)
        return english_dictionary
    elseif set_lang == "french" then
        require(set_lang)
        return french_dictionary
    elseif set_lang == "german" then
        require(set_lang)
        return german_dictionary
    elseif set_lang == "spanish" then
        require(set_lang)
        return spanish_dictionary
    elseif set_lang == "russian" then
        require(set_lang)
        return russian_dictionary
    else
        require("english")
        lang = "english"
        return english_dictionary
    end
end

if cgilua.cgi["langID"] ~= nil then
    lang = cgilua.cgi["langID"]
else
    lang, tmp = settings_if.get_language()
end

curr_dict = set_dictionary(lang)

current_dictionary = function(str)
    dict_str = curr_dict[str]
    if dict_str == nil then
        return "!!"..str
    else
        return dict_str
    end
end
dict = current_dictionary

