require('english')
require('french')
require('german')
require('spanish')
require('russian')

function check_duplicate_entries(file)
    data ={}
    res = true
    for line in io.lines(file) do 
        a = string.find(line,'["',1,true)
        b = string.find(line,'"]',1,true)
        if a ~= nil and b ~= nil and a==1 then
            word = string.sub(line,a+2,b-1) 
            if data[word] ~= nil then
                print("Duplicate entry '"..word.."' in english dictionary")
                res = false
            else
                data[word] = "gnyf"
            end
        end
    end
    return res
end

check_duplicate_entries('english.lua')
check_duplicate_entries('french.lua')
check_duplicate_entries('german.lua')
check_duplicate_entries('spanish.lua')
check_duplicate_entries('russian.lua')
    

for k,v in pairs(english_dictionary) do
    if (german_dictionary[k] == nil) then
        print('"'..k..'" missing in german dictionary')
    end
end
for k,v in pairs(english_dictionary) do
    if (french_dictionary[k] == nil) then
        print('"'..k..'" missing in french dictionary')
    end
end
for k,v in pairs(english_dictionary) do
    if (spanish_dictionary[k] == nil) then
        print('"'..k..'" missing in spanish dictionary')
    end
end
for k,v in pairs(english_dictionary) do
    if (russian_dictionary[k] == nil) then
        print('"'..k..'" missing in russian dictionary')
    end
end

for k,v in pairs(german_dictionary) do
    if (english_dictionary[k] == nil) then
        print('"'..k..'" defined in german dictionary but not english dictionary')
    end
end 
for k,v in pairs(french_dictionary) do
    if (english_dictionary[k] == nil) then
        print('"'..k..'" defined in french dictionary but not english dictionary')
    end
end 
for k,v in pairs(spanish_dictionary) do
    if (english_dictionary[k] == nil) then
        print('"'..k..'" defined in spanish dictionary but not english dictionary')
    end
end 
for k,v in pairs(russian_dictionary) do
    if (english_dictionary[k] == nil) then
        print('"'..k..'" defined in russian dictionary but not english dictionary')
    end
end 

