menu_table = {}
menu_level = 0
menu_index = 0

parents_parent = "none"
parents_parent_index = 0
--print('lua - menu admin password check')
saved_time = cgilua.cookies.get("tt_adm")
if saved_time == nil then
    saved_time = 0
end
--admin_status = msg_if.lua_check_admin_status(saved_time)
--print('lua - admin_status: ' .. admin_status)
page_status = ""

function entry_menu_table (arg)
    show = true
    for i = 1,table.getn(arg.not_shown_on) do
        if arg.not_shown_on[i] == "*" or arg.not_shown_on[i] == product then
            show = false
        end
        if arg.not_shown_on[i] == "ManualPointingTrue" and hasManualPointing == TT_TRUE then
            show = false   
        end
        if arg.not_shown_on[i] == "BluetoothDisabled" and hasBluetooth == TT_FALSE then
            show = false   
        end
        if arg.not_shown_on[i] == "USBDisabled" and hasUSB == TT_FALSE then
            show = false   
        end
        if arg.not_shown_on[i] == "ISDNDisabled" and hasISDN == TT_FALSE then
            show = false   
        end
        if arg.not_shown_on[i] == "WLANDisabled" and hasWLAN == TT_FALSE then
            show = false   
        end
	if arg.not_shown_on[i] == "SIPDisabled" and hasSIP == TT_FALSE then
	    show = false
	end
        if arg.not_shown_on[i] == "EthNetMgmtDisabled" and hasEthNetMgmt == TT_FALSE then
            show = false
        end
    end
    if show == true then
        -- Phone or Phone/Fax subpage hacking
        par = arg.parent
        if CS_SUPPORT == "CS_STANDARD" and par == "Phone/Fax" then
            par = "Phone"    
        end
        table.insert(menu_table,{page_title = arg.page_title,parent = par,menu_level = arg.menu_level, status = arg.status, display = "no"})
    else
        --trace(0, 1, string.format("page not shown on: %s",product))
    end
end


function menu_draw ()

    put(start_of_menu1)
    --parse the menu
    if debug == "yes" then trace(0,1,'parsing menu...') end
    --find the current page in menu
    for i = 1,table.getn(menu_table) do
        if menu_table[i].page_title == page_title then
            page_status = menu_table[i].status
            menu_level = menu_table[i].menu_level
            menu_index = i
            menu_table[i].display = "yes"
            if debug == "yes" then trace(0,1,'current: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end 
        end
    end
    --display parent of current page
    for i = 1,table.getn(menu_table) do
        if menu_table[i].page_title == parent then
            menu_table[i].display = "yes"
            parents_parent = menu_table[i].parent
            if debug == "yes" then trace(0,1,'parent: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end
        end
    end
    --display parents parent if the menu is deep enough
    if menu_level >= 3 then
        for i = 1,table.getn(menu_table) do
            if menu_table[i].page_title == parents_parent then
                parents_parent_index = i
                menu_table[i].display = "yes"
                if debug == "yes" then trace(0,1,'parents parent: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end
            end
        end
    end
    --display children of current page
    --admin_status = msg_if.lua_check_admin_status()
    for i = 1,table.getn(menu_table) do
        if menu_table[i].parent == page_title then
            if menu_table[i].status == "normal" or menu_table[i].status == "special" then
                menu_table[i].display = "yes"           
            elseif (menu_table[i].status == "admin" or menu_table[i].status == "admin_special") and admin_status >= 0 then
                menu_table[i].display = "yes"           
            end
        end     
    end
    --display parents brothers if the menu is deep enough
    if menu_level >= 3 then
        for i = parents_parent_index,table.getn(menu_table) do
            if menu_table[i].menu_level == menu_level-1 and menu_table[i].parent == parents_parent then 
                menu_table[i].display = "yes"
                if debug == "yes" then trace(0,1,'parents parent: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end
            end
        end
    end
    --display all pages with same parent as current page
    for i = 1,table.getn(menu_table) do
        if menu_table[i].parent == parent then  
            if menu_table[i].status ~= "admin_special_only" then
                menu_table[i].display = "yes"
                if debug == "yes" then trace(0,1,'brother: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end
            end
        end
    end
    --allways display top level
    for i = 1,table.getn(menu_table) do
        if menu_table[i].menu_level == 1 then
            menu_table[i].display = "yes"
            if debug == "yes" then trace(0,1,'top: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end
        end
    end
    --debug print
    if debug == "yes" then 
        for i = 1,table.getn(menu_table) do
            trace(0,1,menu_table[i].page_title .. ':')
            trace(0,1,'    parent:  ' .. menu_table[i].parent) 
            trace(0,1,'    level:   ' .. menu_table[i].menu_level)
            trace(0,1,'    display: ' .. menu_table[i].display)
        end
    end 
    --print menu
    for i = 1,table.getn(menu_table) do
        if menu_table[i].menu_level == 1 and menu_table[i].display == "yes" then
            put(level_1_menu_start)
            put('<A HREF="index.lua?pageID=' .. menu_table[i].page_title .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">' .. current_dictionary(string.lower(menu_table[i].page_title)) ..  '</A>\n')
            put(level_1_menu_stop)
        elseif menu_table[i].menu_level == 2 and menu_table[i].display == "yes" then
            put(level_2_menu_start)
            put('<A HREF="index.lua?pageID=' .. menu_table[i].page_title .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">' .. current_dictionary(string.lower(menu_table[i].page_title)) ..  '</A>\n')
            put(level_2_menu_stop)
        elseif menu_table[i].menu_level == 3 and menu_table[i].display == "yes" then
            put(level_3_menu_start)
            put('<A HREF="index.lua?pageID=' .. menu_table[i].page_title .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">' .. current_dictionary(string.lower(menu_table[i].page_title)) ..  '</A>\n')
            put(level_3_menu_stop)
        end
    end

    put(end_of_menu1 .. 482+(vsize-1)*668 .. end_of_menu2)
end

function menu_draw_special ()
    put(start_of_menu1)
    --parse the menu
    if debug == "yes" then trace(0, 1, string.format("parsing special menu...")) end
    --find the current page in menu
    for i = 1,table.getn(menu_table) do
        if menu_table[i].page_title == page_title then
            page_status = menu_table[i].status
            --print('lua - menu_table[i].status: ' .. menu_table[i].status)
            --print('lua - page_status: ' .. page_status)
            menu_level = menu_table[i].menu_level
            menu_index = i
            menu_table[i].display = "yes"
            if debug == "yes" then trace(0, 1, string.format("current: page_title = %s, parent = %s, status = %s",menu_table[i].page_title,menu_table[i].parent,menu_table[i].status)) end 
        end
    end
    --display parent of current page
    for i = 1,table.getn(menu_table) do
        if menu_table[i].page_title == parent then
            menu_table[i].display = "yes"
            parents_parent = menu_table[i].parent
            if debug == "yes" then trace(0, 1, string.format("parent: page_title = %s, parent = %s, status = %s",menu_table[i].page_title,menu_table[i].parent,menu_table[i].status)) end
        end
    end
    --display children of current page
    --print('lua - menu admin password check')
    --admin_status = msg_if.lua_check_admin_status()
    --print('lua - admin_status: ' .. admin_status)
    for i = 1,table.getn(menu_table) do
        if menu_table[i].parent == page_title then
            if menu_table[i].status == "special" then
                menu_table[i].display = "yes"
            elseif (menu_table[i].status == "admin_special" or menu_table[i].status == "admin_special_only") and admin_status >= 0 then
                menu_table[i].display = "yes"
            end
        end     
    end
    --display all pages with same parent as current page
    for i = 1,table.getn(menu_table) do
        if menu_table[i].parent == parent then  
            if menu_table[i].status == "special" then
                menu_table[i].display = "yes"
                if debug == "yes" then trace(0,1,'brother: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end
            elseif (menu_table[i].status == "admin_special" or menu_table[i].status == "admin_special_only") and admin_status >= 0 then
                menu_table[i].display = "yes"
                if debug == "yes" then trace(0,1,'brother: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end
            end
        end
    end
    --allways display top level
    for i = 1,table.getn(menu_table) do
        if menu_table[i].menu_level == 1 and (menu_table[i].status == "special" or menu_table[i].status == "admin_special") then
            menu_table[i].display = "yes"
            if debug == "yes" then trace(0, 1, string.format("top: page_title = %s, parent = %s, status = %s",menu_table[i].page_title,menu_table[i].parent,menu_table[i].status)) end
        end
    end
    --debug print
    if debug == "yes" then 
        for i = 1,table.getn(menu_table) do
            trace(0, 1, string.format("result: page_title = %s, parent = %s",menu_table[i].page_title,menu_table[i].parent,menu_table[i].status))
            trace(0, 1, string.format("result: level = %s, display = %s",menu_table[i].menu_level,menu_table[i].display))
            print(menu_table[i].page_title .. ':')
            print('    parent:  ' .. menu_table[i].parent) 
            print('    level:   ' .. menu_table[i].menu_level)
            print('    display: ' .. menu_table[i].display)
        end
    end 
    --print menu
    for i = 1,table.getn(menu_table) do
        if menu_table[i].menu_level == 1 and menu_table[i].display == "yes" then
            put(level_1_menu_start)
            put('<A HREF="index.lua?pageID=' .. menu_table[i].page_title .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">' .. current_dictionary(string.lower(menu_table[i].page_title)) ..  '</A>\n')
            put(level_1_menu_stop)
        elseif menu_table[i].menu_level == 2 and menu_table[i].display == "yes" then
            put(level_2_menu_start)
            put('<A HREF="index.lua?pageID=' .. menu_table[i].page_title .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">' .. current_dictionary(string.lower(menu_table[i].page_title)) ..  '</A>\n')
            put(level_2_menu_stop)
        elseif menu_table[i].menu_level == 3 and menu_table[i].display == "yes" then
            put(level_3_menu_start)
            put('<A HREF="index.lua?pageID=' .. menu_table[i].page_title .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">' .. current_dictionary(string.lower(menu_table[i].page_title)) ..  '</A>\n')
            put(level_3_menu_stop)
        end
    end

    put(end_of_menu1 .. 586+(vsize-1)*668 .. end_of_menu2)
end

function menu_generate (page_title, parent)
    entry = entry_menu_table
    dofile(LUA_WEB_FILE_ROOT .. '/db.lua')

    --trace(0,1,'lua - table.getn(menu_table): ' .. table.getn(menu_table))
    --for i = 1,table.getn(menu_table) do
    --    trace(0,1,'lua - menu_table[' .. i ..'].page_title: ' .. menu_table[i].page_title)
    --    trace(0,1,'lua - menu_table[' .. i ..'].status: ' .. menu_table[i].status)
    --end

    if usim_string ~= "" then
        if usim_string == "USIM_STATUS_OK" then
            menu_draw()
        else
            menu_draw_special()
        end

    end

end


