menu_table = {}
menu_level = 0
menu_index = 0
parents_parent = "none"
parents_parents_parent = "none"

function entry_table (arg)
    table.insert(menu_table,{page_title = arg.page_title,parent = arg.parent,menu_level = arg.menu_level})
end

function menupath_draw ()
    --Always print home (the first page)
    put('<A HREF="index.lua?pageID=' .. menu_table[1].page_title .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;"> ' .. current_dictionary(string.lower(menu_table[1].page_title)) ..  ' </A>')
    --find the current page in menu
    for i = 1,table.getn(menu_table) do
        if menu_table[i].page_title == page_title then
            menu_level = menu_table[i].menu_level
            menu_index = i
            if debug == "yes" then print('current: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end 
        end
    end
    if menu_level >= 3 then
        for i = 1,table.getn(menu_table) do
            if menu_table[i].page_title == parent then
                parents_parent = menu_table[i].parent
                if debug == "yes" then print('parent: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end 
            end
        end
    end
    if menu_level >= 4 then
        for i = 1,table.getn(menu_table) do
            if menu_table[i].page_title == parents_parent then
                parents_parents_parent = menu_table[i].parent
                if debug == "yes" then print('parents_parent: (' .. menu_table[i].page_title .. ',' .. menu_table[i].parent .. ')') end 
            end
        end
    end
    if string.lower(parents_parents_parent) ~= "none" then
        put('<A HREF="index.lua?pageID=' .. parents_parents_parent .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">> ' .. current_dictionary(string.lower(parents_parents_parent)) ..  ' </A>')
    end
    if string.lower(parents_parent) ~= "none" then
        --print('pp: ' .. parents_parent)
        put('<A HREF="index.lua?pageID=' .. parents_parent .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">> ' .. current_dictionary(string.lower(parents_parent)) ..  ' </A>')
    end
    if menu_level >= 2 then
        put('<A HREF="index.lua?pageID=' .. parent .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">> ' .. current_dictionary(string.lower(parent)) ..  ' </A>')
    end
    if menu_table[1].page_title ~= page_title then
        put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang ..'" STYLE="TEXT-DECORATION: NONE; color: #000000;">> ' .. current_dictionary(string.lower(page_title)) ..  ' </A>')
    end
end


function menupath_generate (page_title)
    entry = entry_table
    dofile(LUA_WEB_FILE_ROOT .. '/db.lua')

    put(start_of_menupath)
    if usim_string == "USIM_STATUS_OK" then
        menupath_draw()
    end
    put(end_of_menupath)
end
