edit_usim = false;

if cgilua.cgi["STANDARD_NO"] ~= nil then
    trace(0, 1, string.format("standard_no: %s",cgilua.cgi["STANDARD_NO"]))
    trace(0, 1, string.format("31_no: %s",cgilua.cgi["31_NO"]))
    trace(0, 1, string.format("udi_no: %s",cgilua.cgi["UDI_NO"]))
    trace(0, 1, string.format("rdi_no: %s",cgilua.cgi["RDI_NO"]))

    mobile_numbers_if.lua_write_mobile_numbers(cgilua.cgi["STANDARD_NO"], cgilua.cgi["31_NO"], cgilua.cgi["UDI_NO"], cgilua.cgi["RDI_NO"])  
elseif cgilua.cgi["phonebookOP"] ~= nil and cgilua.cgi["phonebookOP"] == "edit" then
    --Show edit fields to the user (done later)
    edit_usim = true 
end

str_standard, str_31khz, str_udi, str_rdi = mobile_numbers_if.lua_get_mobile_numbers()

--Generate html code
put(start_of_content)
put('<p id="errortext">' .. error_msg .. '</p>')
put('<table align=left border="'..border_on..'">')
put('    <th colspan="2" align="left"><p class="menutext">' .. current_dictionary("mobile numbers for current sim card") .. '</p></th>\n')

if edit_usim then 

    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '">\n')
    put('    <tr>\n')
    put('        <td align="left"><p>' .. current_dictionary("standard voice") .. '</p></td>\n')
    put('        <td align="left"><input name="STANDARD_NO" value="' .. str_standard .. '"></input></td>\n')
    put('   </tr>\n')
    put('   <tr>\n')
    put('       <td align="left"><p>' ..  current_dictionary("3.1 kHz audio") .. '</p></td>\n')
    put('       <td align="left"><input name="31_NO" value="' .. str_31khz .. '"></input></td>\n')
    put('   </tr>\n')
    put('   <tr>\n')
    put('       <td align="left"><p>' .. current_dictionary("UDI (64kbps)") .. '</p></td>\n')
    put('       <td align="left"><input name="UDI_NO" value="' .. str_udi .. '"></input></td>\n')
    put('   </tr>\n')
    put('   <tr>\n')
    put('       <td align="left"><p>' .. current_dictionary("RDI (56kbps)") .. '</p></td>\n')
    put('       <td align="left"><input name="RDI_NO" value="' .. str_rdi .. '"></input></td>\n')
    put('   </tr>\n')
    put('   <tr>\n')
    put('       <td align="left" colspan="2"><input type="submit" value="'..current_dictionary("save entry")..'"></td>\n')
    put('   </form></tr>')

else

    put('   <tr>\n')
    put('       <td align="left"><p>' .. current_dictionary("standard voice") .. '</p></td>\n')
    put('       <td align="left"><p>' .. str_standard .. '</p></td>\n')
    put('   </tr>\n')
    put('   <tr>\n')
    put('       <td align="left"><p>' ..  current_dictionary("3.1 kHz audio") .. '</p></td>\n')
    put('       <td align="left"><p>' .. str_31khz .. '</p></td>\n')
    put('   </tr>\n')
    put('   <tr>\n')
    put('      <td align="left"><p>' .. current_dictionary("UDI (64kbps)") .. '</p></td>\n')
    put('      <td align="left"><p>' .. str_udi .. '</p></td>\n')
    put('   </tr>\n')
    put('   <tr>\n')
    put('       <td align="left"><p>' .. current_dictionary("RDI (56kbps)") .. '</p></td>\n')
    put('       <td align="left"><p>' .. str_rdi .. '</p></td>\n')
    put('   </tr>\n')
    put('   <tr>\n')
    put('       <td align="left" colspan="2"><p><a href="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;phonebookOP=edit">' .. current_dictionary("edit") .. '</a></p></td>\n')
    put('   </tr>')

end

put('</table>')
put(end_of_content)