
function put_mt_header(title, divclass)
    put('  <div class="' .. divclass .. '">\n')
    put('    <div class="mttitlebar"><p class="menutext">' .. title .. '</p></div>\n')
    put('    <div class="mtcontent">\n')
    put('      <table border="0" cellpadding="0">\n');
    put('      <colgroup span="1" width="130px"></colgroup>\n')
end

function put_mt_field(name, divid)
    put('        <tr>\n')
    put('          <td><p class="mttext">' .. name .. '</p></td>\n')
    put('          <td>\n')
    put('            <div id="' .. divid .. '">\n')
    put('              <p class="mttext">(No info)</p>\n')
    put('            </div>\n')
    put('          </td>\n')
    put('        </tr>\n')
end

function put_mt_footer()
    put('      </table>\n')
    put('    </div>\n')
    put('  </div>\n')
end

ptplot_applets = [[
<div class="mtplot">
    <APPLET CODE="ptolemy.plot.myliveplot.MyLivePlotApplet" 
        archive = "ttplotapplet.jar" width = "467" height = "300">
    <PARAM NAME = "pxgraphargs" VALUE = "-t C/No -x time(s) -y C/No(dBHz) -ly 0,50 -ttadd Cno -ttmem 600" >
</APPLET>
</div>
<div class="mtplot">
    <APPLET CODE="ptolemy.plot.myliveplot.MyLivePlotApplet" 
        archive = "ttplotapplet.jar" width = "467" height = "300">
    <PARAM NAME = "pxgraphargs" VALUE = "-t Rates -x time(s) -y Rate(KB/s) -ly 0,500 -ttadd RxRate -ttadd TxRate -ttmem 600" >
</APPLET>
</div>
]]

-- Copied from html.lua and edited for "fullscreen mode"
start_of_content_mt = [[
                                        <td valign="top">
                                    <!-- left fill -->
                                </td>
                                <td valign="top">
                                    <!-- main content table -->
                                    <table bgcolor="#F2F5F7" align="left" border="0" width="974" width="100%" cellpadding="0" cellspacing="0">
                                        <tr>
                                            <td valign="top">
                                                <!-- content table -->

]]

function mt_field_generate(arg)
    if arg.groupcol == "start" then
        put('<div class="mtcol">\n')
    end
    if arg.group_position == "start" then         
        put_mt_header(arg.grouppretty, arg.divclass)
    end
    put_mt_field(arg.prettyprint, arg.group .. "_" .. arg.field_name)
    if arg.group_position == "end" then 
        put_mt_footer()
    end   
    if arg.groupcol == "end" then
        put('</div>\n')
    end
end

put(start_of_content_mt)

-- Temporary until values are correct
put('<p><B>Debug information</B></p>\n');

-- Add status fields
entry = mt_field_generate
dofile(LUA_WEB_FILE_ROOT .. '/mt_status_db.lua')
put("<p>N/I = Not implemented</p>")

-- Add ptplot applets
if cgilua.cgi["no_applet"] ~= nil and cgilua.cgi["no_applet"] == "1" then
--no applet
else
put(ptplot_applets)
end

-- Add bottom links
put("<a href=\"index.lua\"><p>Home</p></a>")

put(end_of_content)
