
if admin_status < 0 then
    error_msg = current_dictionary("enter password")
end

put(start_of_content)
if admin_status < 0 then
    put('<p><table align=left border="'..border_on..'" cellpadding="0">\n')
    put('<form name="adm_password" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
    put('<tr>\n')
        put('<td align="left"  colspan="3"><p id="errortext">' .. error_msg .. '</p></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<th align="left"><p class="menutext">' .. current_dictionary("administrator logon") .. '</p></th>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' .. current_dictionary("username") .. ':</td>\n')
        put('<td align="left"><input type="text" name="usernameAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' ..current_dictionary("password") .. ':</td>\n')
        put('<td align="left"><input type="password" name="passwordAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p><INPUT type="submit" value="' .. current_dictionary("logon") .. '">&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>\n')
    put('</form>\n')
    put('</table></p>\n')
else

-- ***************
-- local functions
-- ***************
show_filter = function(ix, mac, ip, port, group)
    up_set = false
    put('<tr>')
        put('<td align="left"><p>' ..mac.. '</p></td>') 
        put('<td align="left"><p>' ..ip.. '</p></td>') 
        port_text = port 
        if product == "SBL" then
            if port == 7 then
                port_text = "WLAN"
            elseif port == 9 then
                port_text = "Maintenance"
            end
        end
        put('<td align="left"><p>' ..port_text.. '</p></td>') 
        put('<td align="left"><p>' ..group.. '</p></td>') 
        page_str = ""
        if pageNo ~= 1 then
            page_str = "&amp;PageNo="..pageNo
        end
        put('<td align="center"><p>')
            if ix > 0 and ix < num_entries-1 then
                put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;oper=up&amp;idx=' .. ix ..page_str..'" STYLE="TEXT-DECORATION: NONE; color: #000000;" > <img src="move-up.gif" style="border-width: 0px;"></a>')
                up_set = true
            end
            if ix < num_entries-2 then                
                if up_set then
                    put('/')
                end
                put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;oper=down&amp;idx=' .. ix ..page_str..'" STYLE="TEXT-DECORATION: NONE; color: #000000;" > <img src="move-down.gif" style="border-width: 0px;"></a>')
            end
        put('</p></td>')   
        if ix < num_entries-1 then
            put('<td align="center"><p>')
                put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;oper=edit&amp;idx=' .. ix ..page_str..'">' .. current_dictionary("edit") .. '</a>/')
                put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;oper=delete&amp;idx=' .. ix ..page_str..'">' .. current_dictionary("delete") .. '</a>')
            put('</p></td>')   
        end
    put('</tr>')
end

show_network_device = function(ix, ip1, ip2, ip3, ip4, mac, name)
    put('<tr>')
        put('<td align="left"><p>' ..ip1..'.'..ip2..'.'..ip3..'.'..ip4.. '</p></td>') 
        put('<td align="left"><p>' ..mac.. '</p></td>') 
        put('<td align="left"><p>' ..name.. '</p></td>') 
        page_str = ""
        if devPageNo ~= 1 then
            page_str = "&amp;DevPageNo="..devPageNo
        end
        -- TODO better text than add ?
        put('<td align="center"><p><A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;idx='..edit_idx..'&amp;oper=adddevice&amp;dmac=' .. mac ..'&amp;dip1='..ip1..'&amp;dip2='..ip2..'&amp;dip3='..ip3..'&amp;dip4='..ip4..page_str..'">' .. current_dictionary("add") .. '</a></p></td>')   
    put('</tr>')
end


-- ********************
-- Initiate static data
-- ********************
show_edit_page = false
edit_idx = -1

if cgilua.cgi["oper"] ~= nil then
    trace(0, 1, "in oper");
    if cgilua.cgi["oper"] == "edit" then
        show_edit_page = true
        if cgilua.cgi["idx"] ~= nil then
            edit_idx = tonumber(cgilua.cgi["idx"])
        end
    elseif cgilua.cgi["oper"] == "add" then
        show_edit_page = true
        edit_idx = -1
    elseif cgilua.cgi["oper"] == "adddevice" then
        show_edit_page = true
        if cgilua.cgi["idx"] ~= nil then
            edit_idx = tonumber(cgilua.cgi["idx"])
        end
        trace(0,1,string.format("adddevice %d",edit_idx))    
    elseif cgilua.cgi["oper"] == "delete" then
        if cgilua.cgi["idx"] ~= nil then
            idx = tonumber(cgilua.cgi["idx"])
            nm_if.lua_delete_filter(idx)
        end
    elseif cgilua.cgi["oper"] == "up" then
        if cgilua.cgi["idx"] ~= nil then
            idx = tonumber(cgilua.cgi["idx"])
            -- swap entry idx-1 and idx
            nm_if.lua_swap_filters(idx-1,idx)
        end
    elseif cgilua.cgi["oper"] == "down" then
        if cgilua.cgi["idx"] ~= nil then
            idx = tonumber(cgilua.cgi["idx"])
            -- swap entry idx and idx+1
            nm_if.lua_swap_filters(idx,idx+1)
        end
    end
elseif cgilua.cgi["submit"] ~= nil then
    trace(0, 1, "in submit");

    error_val = 0
    edit_idx = -1
    if cgilua.cgi["idx"] ~= nil then
        edit_idx = tonumber(cgilua.cgi["idx"])
    end
    in_mac = ""
    in_ip1 = 0
    in_ip2 = 0
    in_ip3 = 0
    in_ip4 = 0
    in_port = 0
    in_group = -1
    if cgilua.cgi["mac"] ~= nil then
        in_mac = cgilua.cgi["mac"]
    end
    if cgilua.cgi["ip1"] ~= nil then
        in_ip1 = tonumber(cgilua.cgi["ip1"])
        if in_ip1 == nil then
            in_ip1 = 0
        end
    end
    if cgilua.cgi["ip2"] ~= nil then
        in_ip2 = tonumber(cgilua.cgi["ip2"])
        if in_ip2 == nil then
            in_ip2 = 0
        end
    end
    if cgilua.cgi["ip3"] ~= nil then
        in_ip3 = tonumber(cgilua.cgi["ip3"])
        if in_ip3 == nil then
            in_ip3 = 0
        end
    end
    if cgilua.cgi["ip4"] ~= nil then
        in_ip4 = tonumber(cgilua.cgi["ip4"])
        if in_ip4 == nil then
            in_ip4 = 0
        end
    end
    if cgilua.cgi["lan_port"] ~= nil then
        in_port = tonumber(cgilua.cgi["lan_port"])
        if in_port == nil then
            in_port = 0
        end
    end
    if cgilua.cgi["group"] ~= nil then
        in_group = tonumber(cgilua.cgi["group"])
        if in_group == nil then
            in_group = 0
        end
    end

    val = nm_if.lua_set_filter_entry(edit_idx,string.gsub(in_mac, ":", ""),in_ip1,in_ip2,in_ip3,in_ip4,in_port,in_group)
    if val == 1 then
        error_msg = current_dictionary("max classification entries exceeded")
    elseif val == 2 then
        error_msg = current_dictionary("empty classification entry not allowed")
    end

    if error_msg ~= "" then
        show_edit_page = true
        --edit_idx already set
    end
end

    trace(0, 1, string.format("edit_idx %d",edit_idx));

-- *****************
-- get current state
-- *****************
num_entries = 0
filter_table = {}

mac_idx = 1
ip_set_idx = 2
ip1_idx = 3
ip2_idx = 4
ip3_idx = 5
ip4_idx = 6
port_idx = 7
nug_idx = 8

nug_title = {}
for i = 0, 10 do
    nug_title[i] = nm_if.lua_get_nug_name(i)
    x1, enabled, x3 = nm_if.lua_get_nug_config(i)
    if enabled == TT_FALSE then
        nug_title[i] = nug_title[i]..' ('..current_dictionary("disabled")..')'
    end
end

num_entries, max_entries = nm_if.lua_get_filter_cnt()
for i = 0, num_entries-1 do
    mac_set, mac, ip_set, ip1, ip2, ip3, ip4, port_set, port, group =  nm_if.lua_get_filter_entry(i)
    if not mac_set then
        mac = "*"
    end
    if not port_set then
        port = "*"
    end
    table.insert(filter_table, {mac, ip_set, ip1, ip2, ip3, ip4, port, group})
end
--nm_if.lua_rel_filter_table(false)
-- TODO remove
for i, data in ipairs(filter_table) do
    trace(0, 1, string.format("%d: %s %s %s %s %s %s %s",i,data[mac_idx],data[ip1_idx],data[ip2_idx],data[ip3_idx],data[ip4_idx],data[port_idx],nug_title[data[nug_idx]]))
end

if show_edit_page and cgilua.cgi["oper"] == "add" then
    if num_entries == max_entries then
        error_msg = current_dictionary("max classification entries exceeded")
        show_edit_page = false
    end
end

-- pageNumber
if cgilua.cgi["PageNo"] ~= nil then
    pageNo = tonumber(cgilua.cgi["PageNo"])
else
    pageNo = 1 
end    

--Find number of pages
--entriesPerPage = 20
--rem = math.mod(num_entries, entriesPerPage) 
--nPages = (num_entries - rem)/entriesPerPage
--if rem > 0 then
--   nPages = nPages + 1
--end    

-- TODO
-- check access permission
disabled_string = ''
allowed = true
if admin_status < 0 then
    allowed = msg_if.lua_get_user_permissions("change_lan")
    if not allowed then 
        disabled_string = ' disabled '
        error_msg = current_dictionary("admin_locked")
    end
end

put('<p id="errortext">' .. error_msg .. '</p>')
put('<p><table border="'..border_on..'" cellpadding="0" align="left" valign="top" width="80%">')

put('<form name="classification_form" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')

if show_edit_page then

    num_devices = 0
    device_table = {}
    dev_mac_idx = 1
    dev_ip1_idx = 2
    dev_ip2_idx = 3
    dev_ip3_idx = 4
    dev_ip4_idx = 5
    dev_name_idx = 6

    num_devices = nm_if.lua_get_device_list_cnt()
    for i = 0, num_devices-1 do
        mac, ip_addr1, ip_addr2, ip_addr3, ip_addr4, name = nm_if.lua_get_device_list_entry(i)
        table.insert(device_table, {mac, ip_addr1, ip_addr2, ip_addr3, ip_addr4, name})
    end
    nm_if.lua_rel_device_list()

    -- add sort handling here
    sort=""

    -- pageNumber
    if cgilua.cgi["DevPageNo"] ~= nil then
        devPageNo = tonumber(cgilua.cgi["DevPageNo"])
    else
        devPageNo = 1 
    end    
    
    --Find number of pages
    entriesPerPage = 20
    rem = math.mod(num_devices, entriesPerPage) 
    nPages = (num_devices - rem)/entriesPerPage
    if rem > 0 then
       nPages = nPages + 1
    end    

    if edit_idx == -1 then
        heading_string = current_dictionary("enter values for new entry")
    else
        heading_string = current_dictionary("edit entry")
    end

    mac = ""
    ip1 = ""
    ip2 = ""
    ip3 = ""
    ip4 = ""
    port = ""
    group = -1;
    if edit_idx ~= -1 then
        mac = filter_table[edit_idx+1][mac_idx]
        ip_set = filter_table[edit_idx+1][ip_set_idx]
        ip1 = filter_table[edit_idx+1][ip1_idx]
        ip2 = filter_table[edit_idx+1][ip2_idx]
        ip3 = filter_table[edit_idx+1][ip3_idx]
        ip4 = filter_table[edit_idx+1][ip4_idx]
        if not ip_set then
            ip1 = ""
            ip2 = ""
            ip3 = ""
            ip4 = ""
        end
        port = filter_table[edit_idx+1][port_idx]
        group = filter_table[edit_idx+1][nug_idx]
    end
    if cgilua.cgi["oper"] ~= nil then
        if cgilua.cgi["oper"] == "adddevice" then
            mac = cgilua.cgi["dmac"]
            ip_set = true
            ip1 = cgilua.cgi["dip1"]
            ip2 = cgilua.cgi["dip2"]
            ip3 = cgilua.cgi["dip3"]
            ip4 = cgilua.cgi["dip4"]
        end
    end
    
    put('<th align="left" colspan="3"><p class="menutext">'..heading_string .. '</p></th>\n') 
    put('<tr><td align="left" colspan="3"><p>'..current_dictionary("classification entry guide text")..'</p></td></tr>')
    put('<tr>')
        put('<td align="left"><p>'..current_dictionary("mac address")..'</p></td>')
        put('<td align="left"><p><input '..disabled_string..'type="text" name="mac" maxlength="17" size="21" value="'..mac ..'"></p></td>')
    put('</tr>\n')
    put('<tr>')
        put('<td align="left"><p>'..current_dictionary("ip address")..'</p></td>')
        put('<td align="left"><p><input '..disabled_string..' type="text" maxlength="3" name="ip1" size="3" value='..ip1..'>.')
                            put('<input '..disabled_string..' type="text" maxlength="3" name="ip2" size="3" value='..ip2..'>.')
                            put('<input '..disabled_string..' type="text" maxlength="3" name="ip3" size="3" value='..ip3..'>.')
                            put('<input '..disabled_string..' type="text" maxlength="3" name="ip4" size="3" value='..ip4..'>')
        put('</p></td>')
    put('</tr>\n')

    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("lan port") .. '</p></td>')
        put('<td align="left"><select '..disabled_string..' size="1" name="lan_port">\n')
        put('    <option ' ..selected_text(port == "").. 'value="0">  </option>\n')
        put('    <option ' ..selected_text(port == "1" or port == 1).. '>1</option>\n')
        put('    <option ' ..selected_text(port == "2" or port == 2).. '>2</option>\n')
        put('    <option ' ..selected_text(port == "3" or port == 3).. '>3</option>\n')
        put('    <option ' ..selected_text(port == "4" or port == 4).. '>4</option>\n')
        if product == "SBL" then
            put('    <option ' ..selected_text(port == "5" or port == 5).. '>5</option>\n')
            put('    <option ' ..selected_text(port == "6" or port == 6).. '>6</option>\n')
            put('    <option ' ..selected_text(port == "7" or port == 7).. 'value="7">WLAN</option>\n')
            put('    <option ' ..selected_text(port == "9" or port == 9).. 'value="9">Maintenance</option>\n')
        end        
        put('</select></td>')
    put('</tr>\n')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("network user group") .. '</p></td>')
        put('<td align="left"><select '..disabled_string..' size="1" name="group">\n')
        for i = 0, 10 do
            put(' <option '..selected_text(group==i).. ' value="'..i..'">'..nug_title[i]..'</option>\n')
        end
        put('</select></td>')
    put('</tr>\n')

    put('<tr>')
    put('<td align="left"><p><input  ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
        put('&nbsp;&nbsp;<input  ' .. disabled_string .. ' type="submit" name="submit_back" value="' .. current_dictionary("cancel") .. '"></p>')
        put('<input type="hidden" name="idx" value="'..edit_idx..'"></td>\n')
    put('</tr>')
    put('<tr><td></td></tr>')

    put('<tr>')
        put('<th align="left" colspan="4"><p class="menutext">' ..current_dictionary("network devices") .. '&nbsp;</p></th>\n') 
    put('</tr>')
    put('<tr>')
        put('<th align="left" width="20%"><p>' ..current_dictionary("ip address") .. '</p></th>')
        put('<th align="left" width="30%"><p>' ..current_dictionary("mac address") .. '</p></th>') 
        put('<th align="left" width="20%"><p>' ..current_dictionary("device name") .. '</p></th>\n') 
        put('<th align="left"></th>\n') 
    put('</tr>')
    
    -- Calculate entry startIx and stopIx for the page to be shown
    startIx = 1 + (devPageNo - 1)*entriesPerPage
    if devPageNo < nPages then
        stopIx = startIx + entriesPerPage - 1
    else
        stopIx = num_devices
    end
    
    for i = startIx, stopIx do
        show_network_device(i, device_table[i][dev_ip1_idx],device_table[i][dev_ip2_idx],device_table[i][dev_ip3_idx],device_table[i][dev_ip4_idx], device_table[i][dev_mac_idx], device_table[i][dev_name_idx])
    end        

    oper_str = ''
    if edit_idx == -1 then
        oper_str = '&amp;oper=add'
    else
        oper_str = '&amp;oper=edit&amp;idx='..edit_idx    
    end
    if nPages > 1 then
        put('<tr><td colspan="4" align="left">\n')
        put('<p class="menutext">')
            for i = 1, nPages do
                link_generate (page_title, "&amp;DevPageNo=" ..i.. sort..oper_str,  i, "direct")
                put(" ")
            end    
        put('</p>\n')
        put('</td></tr>') 
    end
else
    put('<tr>')
        put('<th align="left" colspan="4"><p class="menutext">' ..current_dictionary("network classification table") .. '&nbsp;</p></th>\n') 
    put('</tr>')
    put('<tr>')
        put('<th align="left" width="22%"><p>' ..current_dictionary("mac address") .. '</p></th>') 
        put('<th align="left" width="20%"><p>' ..current_dictionary("ip address") .. '</p></th>')
        put('<th align="left" width="14%"><p>' ..current_dictionary("lan port") .. '</p></th>')
        put('<th align="left"><p>' ..current_dictionary("network user group") .. '</p></th>')
    put('</tr>')
    
    for i, data in ipairs(filter_table) do
        ip_str = data[ip1_idx]..'.'..data[ip2_idx]..'.'..data[ip3_idx]..'.'..data[ip4_idx]
        if not data[ip_set_idx] then
            ip_str="*"
        end
        show_filter(i-1, data[mac_idx],ip_str,data[port_idx],nug_title[data[nug_idx]])
    end
    
    -- Calculate entry startIx and stopIx for the page to be shown
    --startIx = 1 + (pageNo - 1)*entriesPerPage
    --if pageNo < nPages then
    --    stopIx = startIx + entriesPerPage - 1
    --else
    --    stopIx = num_devices
    --end
    --for i = startIx, stopIx do
    --    show_filter(i, data[mac_idx],data[ip_idx],data[port_idx],data[nug_idx])
    --end        
    
    if allowed then
        put('<tr><td colspan="5" align="left"><p>')
        link_generate (page_title, "&amp;oper=add&amp;PageNo="..pageNo , "add", "norm")
        put('</p></td></tr>')
        put('<tr></tr>')
        put('<tr><td colspan="5" align="left"><p id=errortext>'..current_dictionary("changes to this page requires reboot")..'</p></td></tr>')

    end
    
--    if nPages > 1 then
--        put('<tr><td colspan="4" align="left">\n')
--        put('<p class="menutext">')
--            for i = 1, nPages do
--                link_generate (page_title, "&amp;PageNo=" ..i ,  i, "direct")
--                put(" ")
--            end    
--        put('</p>\n')
--        put('</td></tr>') 
--    end
end
put('</form>')
put('</table></p>\n')

end
put(end_of_content)



