if hasEthNetMgmt == TT_TRUE and admin_status < 0 then
    error_msg = current_dictionary("enter password")
end

put(start_of_content)

if product == "SBL" then
    local flex_multi_user, flex_wlan = msg_if.lua_get_flex_features_at_startup() 
        
    if not flex_multi_user then 
        error_msg = dict("multiuser flex not enabled") 
        put('<p id="errortext">' .. error_msg .. '</p>') 
        put(end_of_content) 
        return 
    end 
end
 
if hasEthNetMgmt == TT_TRUE and admin_status < 0 then
    put('<p><table align=left border="'..border_on..'" cellpadding="0">\n')
    put('<form name="adm_password" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
    put('<tr>\n')
        put('<td align="left"  colspan="3"><p id="errortext">' .. error_msg .. '</p></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<th align="left"><p class="menutext">' .. current_dictionary("administrator logon") .. '</p></th>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' .. current_dictionary("username") .. ':</td>\n')
        put('<td align="left"><input type="text" name="usernameAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' ..current_dictionary("password") .. ':</td>\n')
        put('<td align="left"><input type="password" name="passwordAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p><INPUT type="submit" value="' .. current_dictionary("logon") .. '">&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>\n')
    put('</form>\n')
    put('</table></p>\n')
else
    
    if cgilua.cgi["radio_pppoe"] ~= nil then
        msg_if.lua_set_pppoe(tonumber(cgilua.cgi["radio_pppoe"]))
    end

    pppoe_enabled = msg_if.lua_get_pppoe()

    disabled_string = ""
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_lan")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end

    --print html
    put('<p id="errortext">' .. error_msg .. '</p>')
    put('<p><table border="'..border_on..'" cellpadding="0" align="left" valign="top">')

    put('<form name="pppoe_interfaces" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')

    put('<tr>')
        put('<td align="left" ><p class="menutext">' .. current_dictionary("pppoe") .. '</p></td>\n')
    put('</tr>')  

    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("pppoe") .. '</p></td>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" name="radio_pppoe" value="1" ' ..checked_text(pppoe_enabled).. '>' .. current_dictionary("enabled"))
        put('&nbsp;<input  ' .. disabled_string .. ' type="radio" name="radio_pppoe" value="0" ' ..checked_text(not pppoe_enabled).. '>' .. current_dictionary("disabled") .. '</p></td>\n')
    put('</tr>')                    

    --submit button
    put('<tr>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
        put('&nbsp;&nbsp;<input  ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>')
    put('</form>')
    put('</table></p>\n')

end
put(end_of_content)

