sms_used_slots, sms_max_slots, sc_addr = msg_if.lua_max_info()

error_msg = ""
debug_msg = ""

local function get_numbers()
    local myq=Queue.lookup("xavante")
    local q=Queue.lookup("lua_if")

    local message_table=
    {
        ["head"] = {
            ["messageId"] = "LUAIF_READ_NUMBERS_FROM_USIM_REQ",
            ["returnQueue"] = myq,
            ["returnMessageId"] = "LUAIF_READ_NUMBERS_FROM_USIM_RSP"
        }
    }
    local message=msg_if.to_std_msg(message_table)
    q:put(message)
    return_message = myq:get(5000)
    if not return_message then
        return "get numbers status: unknown"
    end
    return_message_table = msg_if.get_numbers_msg(return_message)
    return return_message_table
end

t = {}
ip_addr = msg_if.read_config_db_ip_addr(t)
mac, serial, pcb, imei, mac_wlan = msg_if.lua_read_config_db_sysconf_info()
ver = msg_if.print_version_info()
numbers = get_numbers()
--put('<--' .. get_numbers() .. '-->');

put(start_of_content)
--Print any error message
put('<table align=center><tr><td><p id="errortext">')
put(error_msg .. '</p></td></tr></table>')

put('<p><table align=left border="'..border_on..'" cellpadding="0">')
put('<tr>')
put('<td align="left"><p>'.. current_dictionary("local ip address") ..':</p></td><td><p>' .. ip_addr.ip_addr3 .. '.' .. ip_addr.ip_addr2 ..'.'.. ip_addr.ip_addr1 ..'.'.. ip_addr.ip_addr0..'</p></td>')
put('</tr>')
put('<tr><td align="left"><p>'.. current_dictionary("imei number") ..':</p></td><td><p>'..imei..'</p></td></tr>')
put('<tr><td align="left"><p>'.. current_dictionary("sms service center") ..':</p></td><td><p>'.. sc_addr ..'</p></td></tr>')
--put('<tr><td></td><td align="left">Voice mail service number:</td><td></td></tr>')
--put('<tr><td></td><td align="left">Standard voice mobile number:</td><td>' ..'</td></tr>')     --numbers.s_number
--put('<tr><td></td><td align="left">Premium voice mobile number:</td><td>' ..'</td></tr>') --numbers.p_number

put('<tr><td align="left"><p>' .. current_dictionary("software version") .. ':</p></td><td><p>'..ver..'</p></td></tr>')
put('<tr><td align="left"><p>' .. current_dictionary("unit serial number") .. ':</p></td><td><p>'..serial..'</p></td></tr>')
put('<tr><td align="left"><p>' .. current_dictionary("main pcb number") .. ':</p></td><td><p>'..pcb..'</p></td></tr>')
put('<tr><td align="left"><p>' .. current_dictionary("mac address") .. ':</p></td><td><p>'..mac..'</p></td></tr>')
if hasWLAN == TT_TRUE then
    put('<tr><td align="left"><p>' .. current_dictionary("mac wlan") .. ':</p></td><td><p>'..mac_wlan..'</p></td></tr>')
end    

put('</table></p>')
put(end_of_content)

