selected_text = function (expr)
  if (expr) then
    return ' selected '
  else
    return ''
  end
end

sat_list = {"Asia-Pacific","EMEA","Americas","Auto"}

if cgilua.cgi["sat"] ~= nil then
    trace(0, 1, string.format("lua - sat: %s",cgilua.cgi["sat"]))
    for i = 1,table.getn(sat_list) do
        if cgilua.cgi["sat"] == sat_list[i] then
            msg_if.lua_set_sat_selection(i)
        end
    end
end

sat_select = msg_if.lua_get_sat_selection()


put(start_of_content)
--Print any error message
put('<table align=center><tr><td><p id="errortext">')
put(error_msg .. '</p></td></tr></table>')

put('<form name="settings_interfaces" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')
put('<p><table align=left border="'..border_on..'" cellpadding="0">')
if product == "SBL" then
    put('<tr><th align="left" colspan="2"><p class="menutext">'..current_dictionary("satellite selection")..'</p></th></tr>')
end
put('<tr>')
    put('<td align="left" valign="top"><p>'.. current_dictionary("satellite selection") ..':</p></td><td><p>')
    put('<select size="5" name="sat">')
    for i = 1,table.getn(sat_list) do
        put('<option ' ..selected_text((sat_select) == i).. '>' .. sat_list[i] .. '</option>\n')
    end
    put('</select></p></td>')
put('</tr>')        
put('<tr>')
    put('<td align="left"><p><INPUT type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
    put('&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
put('</tr>')
put('</table></p>\n')
put('</form>\n')
put(end_of_content)

