js_fs = [[
    <script type="text/javascript">
    function checkRequire(form,text)
    {
        if (form.pin.value.length == 0)
        {
            alert(text);
            form.pin.focus();
            return false;    
        }
        return true;
    }

    function checkChange(form,text1,text2,text3)
    {
        if (form.pw_old.value.length == 0)
        {
            alert(text1);
            form.pw_old.focus();
            return false;    
        }
        if (form.pw_new1.value.length < 4)
        {
            alert(text2);
            form.pw_new1.focus();
            return false;    
        }
        if (form.pw_new1.value != form.pw_new2.value)
        {
            alert(text3);
            form.pw_new1.focus();
            return false;
        }
        return true;
    }
    
    </script>
]]

x, pin_state = msg_if.lua_usim_msg_status()
trace(0,1,string.format("usim status: %s, pin status %d",x,pin_state))
    
if cgilua.cgi["usimOP"] == "Require" then
    --  main_sim_pin_res, main_req_pin_state = msg_if.lua_set_pin_state(tonumber(cgilua.cgi["req_pin"]),cgilua.cgi["pin"])      
    if main_sim_pin_res ~= "USIM_STATUS_OK" then
        trace(0,1, string.format("require pin result: %s",main_sim_pin_res)) 
        error_msg = current_dictionary("pin not correct")
    end
elseif cgilua.cgi["usimOP"] == "Change" then
    --  main_sim_pin_res = msg_if.lua_change_pin(cgilua.cgi["pw_old"], cgilua.cgi["pw_new1"])
    if main_sim_pin_res == "USIM_STATUS_FAIL" and pin_state ~= 0 then
        error_msg = current_dictionary("change pin not possible")        
    elseif main_sim_pin_res ~= "USIM_STATUS_OK" then
        trace(0,1, string.format("change pin result: %s",main_sim_pin_res)) 
        error_msg = current_dictionary("pin not correct")
    end
end

put('\n')

put(start_of_content)
put(js_fs)

put('<p id="errortext">' .. error_msg .. '</p>')

put('<p><table align="left" border="'..border_on..'" cellpadding="0">\n')
put('<form name="require_pin" method="post" onsubmit=\'return checkRequire(this,"'..current_dictionary("please enter pin")..'");\' action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '&amp;usimOP=Require">\n')

put('<tr>')
    put('<th align="left" colspan="2"><p class="menutext">' ..current_dictionary("require pin").. '</p>')
    put('</th>')
put('</tr>')
    
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("require pin on startup")..'</p></td>')
    put('<td align="left"><p><input type="radio" name="req_pin" value="1"'..checked_text(pin_state==0)..' >&nbsp;' ..current_dictionary("enabled"))
    put('&nbsp;<input type="radio" name="req_pin" value="0"'..checked_text(pin_state~=0)..' >&nbsp;' ..current_dictionary("disabled")..'</p></td>')
put('</tr>')
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("pin")..'</p></td>')
    put('<td align="left"><p><input type="password" maxlength="8" name="pin"></p></td>')
put('</tr>')
put('<tr>\n')
    put('<td align="left" colspan="2">')
    put('<p><INPUT type="submit" value="' .. current_dictionary("apply") .. '">')
    put('&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
put('</tr>')
put('<tr>')
    put('<td align="left" colspan="3"><hr></td>\n')
put('</tr>')
put('</form>\n')

text1 = current_dictionary("please enter pin")
text2 = current_dictionary("please enter pin - at least 4 digits")
text3 = current_dictionary("new pins not the same") 
put('<form name="change_pin" method="post" onsubmit=\'return checkChange(this,"'..text1..'","'..text2..'","'..text3..'");\' action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '&amp;usimOP=Change">\n')

put('<tr>')
    put('<th align="left" colspan="2"><p class="menutext">' ..current_dictionary("change pin").. '</p>')
    put('</th>')
put('</tr>')
    
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("old pin")..'</p></td>')
    put('<td align="left"><p><input type="password" maxlength="8" name="pw_old"></p></td>')
put('</tr>')
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("new pin")..'</p></td>')
    put('<td align="left"><p><input type="password" maxlength="8" name="pw_new1"></p></td>')
put('</tr>')
put('<tr>')
    put('<td align="left"><p>'..current_dictionary("confirm pin")..'</p></td>')
    put('<td align="left"><p><input type="password" maxlength="8" name="pw_new2"></p></td>')
put('</tr>')
   
put('<tr>\n')
    put('<td align="left" colspan="2">')
    put('<p><INPUT type="submit" value="' .. current_dictionary("apply") .. '">')
    put('&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
put('</tr>')

put('</form>\n') 
put('</table></p>\n')
put(end_of_content)

