permissions_changed = false;
permissions = {}

if cgilua.cgi["allow_upload"] ~= nil then
  permissions_changed = true;
  permissions[0] = tonumber(cgilua.cgi["allow_upload"])
end

if cgilua.cgi["allow_edit_phone_book"] ~= nil then
  permissions_changed = true;
  permissions[1] = tonumber(cgilua.cgi["allow_edit_phone_book"])
end

if cgilua.cgi["allow_change_phone"] ~= nil then
  permissions_changed = true;
  permissions[2] = tonumber(cgilua.cgi["allow_change_phone"])
end

if cgilua.cgi["allow_change_usb"] ~= nil then
  permissions_changed = true;
  permissions[3] = tonumber(cgilua.cgi["allow_change_usb"])
end

if cgilua.cgi["allow_change_lan"] ~= nil then
  permissions_changed = true;
  permissions[4] = tonumber(cgilua.cgi["allow_change_lan"])
end

if cgilua.cgi["allow_change_isdn"] ~= nil then
  permissions_changed = true;
  permissions[5] = tonumber(cgilua.cgi["allow_change_isdn"])
end

if cgilua.cgi["allow_change_wlan"] ~= nil then
  permissions_changed = true;
  permissions[6] = tonumber(cgilua.cgi["allow_change_wlan"])
end

if cgilua.cgi["allow_change_bt"] ~= nil then
  permissions_changed = true;
  permissions[7] = tonumber(cgilua.cgi["allow_change_bt"])
end

if cgilua.cgi["allow_change_common"] ~= nil then
  permissions_changed = true;
  permissions[8] = tonumber(cgilua.cgi["allow_change_common"])
end

if cgilua.cgi["allow_change_general"] ~= nil then
  permissions_changed = true;
  permissions[9] = tonumber(cgilua.cgi["allow_change_general"])
end

if cgilua.cgi["allow_change_supplementary"] ~= nil then
  permissions_changed = true;
  permissions[10] = tonumber(cgilua.cgi["allow_change_supplementary"])
end

if cgilua.cgi["allow_at_bluetooth"] ~= nil then
  permissions_changed = true;
  permissions[11] = tonumber(cgilua.cgi["allow_at_bluetooth"])
end

if cgilua.cgi["allow_at_lan_wlan"] ~= nil then
  permissions_changed = true;
  permissions[12] = tonumber(cgilua.cgi["allow_at_lan_wlan"])
end

if cgilua.cgi["allow_at_usb"] ~= nil then
  permissions_changed = true;
  permissions[13] = tonumber(cgilua.cgi["allow_at_usb"])
end

if cgilua.cgi["allow_change_sip"] ~= nil then
  permissions_changed = true;
  permissions[14] = tonumber(cgilua.cgi["allow_change_sip"])
end

if cgilua.cgi["allow_self_test"] ~= nil then
  permissions_changed = true;
  permissions[15] = tonumber(cgilua.cgi["allow_self_test"])
end

if cgilua.cgi["allow_change_discrete_io"] ~= nil then
  permissions_changed = true;
  permissions[16] = tonumber(cgilua.cgi["allow_change_discrete_io"])
end

if cgilua.cgi["allow_pdp_idl"] ~= nil then
  permissions_changed = true;
  permissions[17] = tonumber(cgilua.cgi["allow_pdp_idl"])
end

if permissions_changed then
   msg_if.lua_set_user_permissions(permissions[17],permissions[16],permissions[15],permissions[14],permissions[0],permissions[1],permissions[2],permissions[3],permissions[4],permissions[5],permissions[6],permissions[7],permissions[8],permissions[9],permissions[10],permissions[11],permissions[12],permissions[13])
end


put(start_of_content)
put('<p id="errortext">' .. error_msg .. '</p>')
put('<TABLE align="left" border="'..border_on..'" width="60%">\n')
put('<form name="user_permissions" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')
put('  <tbody>\n')
put('    <tr>\n')
put('      <th colspan="3" align="left"><p class="menutext">'..current_dictionary("allow users to")..':</p></th>\n')
put('    </tr>\n')

put('    <tr>\n')
put('      <td><p>'..current_dictionary("upload firmware")..'</p></td>\n')

checked = msg_if.lua_get_user_permissions("upload_firmware")
put('      <td><p><input type="radio" name="allow_upload" value="1" ' .. checked_text(checked) ..'>yes</input></p></td>\n')
put('      <td><p><input type="radio" name="allow_upload" value="0" ' .. checked_text(not checked) .. '>no</input></p></td>\n')
put('    </tr>\n')

put('    <tr>\n')
put('      <td><p>'..current_dictionary("edit phone book")..'</p></td>\n')
checked = msg_if.lua_get_user_permissions("edit_phone_book")
put('      <td><p><input type="radio" name="allow_edit_phone_book" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
put('      <td><p><input type="radio" name="allow_edit_phone_book" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
put('    </tr>\n')

put('    <tr>\n')
put('      <td><p>'..current_dictionary("change phone settings")..'</p></td>\n')
checked = msg_if.lua_get_user_permissions("change_phone")
put('      <td><p><input type="radio" name="allow_change_phone" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
put('      <td><p><input type="radio" name="allow_change_phone" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
put('    </tr>\n')

if hasUSB == TT_TRUE then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("change usb settings")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("change_usb")
    put('      <td><p><input type="radio" name="allow_change_usb" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_change_usb" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else
   valueString = "0"
   if msg_if.lua_get_user_permissions("change_usb") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_change_usb" value="' .. valueString .. '"></input>')
end

put('    <tr>\n')
put('      <td><p>'..current_dictionary("change lan settings")..'</p></td>\n')
checked = msg_if.lua_get_user_permissions("change_lan")
put('      <td><p><input type="radio" name="allow_change_lan" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
put('      <td><p><input type="radio" name="allow_change_lan" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
put('    </tr>\n')

if hasWLAN == TT_TRUE then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("change wlan settings")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("change_wlan")
    put('      <td><p><input type="radio" name="allow_change_wlan" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_change_wlan" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else 
   valueString = "0"
   if msg_if.lua_get_user_permissions("change_wlan") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_change_wlan" value="' .. valueString .. '"></input>')
end

if hasBluetooth == TT_TRUE then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("change bluetooth settings")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("change_bluetooth")
    put('      <td><p><input type="radio" name="allow_change_bt" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_change_bt" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else 
   valueString = "0"
   if msg_if.lua_get_user_permissions("change_bluetooth") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_change_bt" value="' .. valueString .. '"></input>')
end

if hasISDN == TT_TRUE then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("change isdn settings")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("change_isdn")
    put('      <td><p><input type="radio" name="allow_change_isdn" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_change_isdn" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else 
   valueString = "0"
   if msg_if.lua_get_user_permissions("change_isdn") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_change_isdn" value="' .. valueString .. '"></input>')
end

if hasSIP == TT_TRUE then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("change ip handset settings")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("change_sip")
    put('      <td><p><input type="radio" name="allow_change_sip" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_change_sip" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else 
   valueString = "0"
   if msg_if.lua_get_user_permissions("change_sip") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_change_sip" value="' .. valueString .. '"></input>')
end

if product ~= "E300" and product ~= "E500" and product ~= "E700" and product ~= "E527" then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("change discrete io settings")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("change_discrete_io")
    put('      <td><p><input type="radio" name="allow_change_discrete_io" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_change_discrete_io" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else 
   valueString = "0"
   if msg_if.lua_get_user_permissions("change discrete io settings") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="change_discrete_io" value="' .. valueString .. '"></input>')
end

put('    <tr>\n')
put('      <td><p>'..current_dictionary("change supplementary services")..'</p></td>\n')
checked = msg_if.lua_get_user_permissions("change_supplementary")
put('      <td><p><input type="radio" name="allow_change_supplementary" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
put('      <td><p><input type="radio" name="allow_change_supplementary" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
put('    </tr>\n')

put('    <tr>\n')
put('      <td><p>'..current_dictionary("change common settings")..'</p></td>\n')
checked = msg_if.lua_get_user_permissions("change_common")
put('      <td><p><input type="radio" name="allow_change_common" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
put('      <td><p><input type="radio" name="allow_change_common" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
put('    </tr>\n')

put('    <tr>\n')
put('      <td><p>'..current_dictionary("change general settings")..'</p></td>\n')
checked = msg_if.lua_get_user_permissions("change_general")
put('      <td><p><input type="radio" name="allow_change_general" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
put('      <td><p><input type="radio" name="allow_change_general" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
put('    </tr>\n')

if product ~= "E300" and product ~= "E500" and product ~= "E700" and product ~= "E527" then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("perform self test")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("perform_self_test")
    put('      <td><p><input type="radio" name="allow_self_test" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_self_test" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else 
   valueString = "0"
   if msg_if.lua_get_user_permissions("perform_self_test") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_self_test" value="' .. valueString .. '"></input>')
end

if product ~= "E300" and product ~= "E500" and product ~= "E700" and product ~= "E527" then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("control pdp from idl")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("control_pdp_from_idl")
    put('      <td><p><input type="radio" name="allow_pdp_idl" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_pdp_idl" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else 
   valueString = "0"
   if msg_if.lua_get_user_permissions("control_pdp_from_idl") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_pdp_idl" value="' .. valueString .. '"></input>')
end

put('    <tr>\n')
put('      <th colspan="3" align="left"><p class="menutext">'..current_dictionary("allow at commands")..':</p></th>\n')
put('    </tr>\n')

put('    <tr>\n')
put('      <td align=left colspan=3><p id=errortext>'..current_dictionary("changes to at cmds require reboot")..'</p></td>\n')
put('    </tr>\n')

if hasUSB == TT_TRUE then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("usb interface")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("at_usb")
    put('      <td><p><input type="radio" name="allow_at_usb" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_at_usb" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else
   valueString = "0"
   if msg_if.lua_get_user_permissions("at_usb") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_at_usb" value="' .. valueString .. '"></input>')
end

put('    <tr>\n')
if hasWLAN == TT_TRUE then
    put('      <td><p>'..current_dictionary("lan/wlan interface")..'</p></td>\n')
else
    put('      <td><p>'..current_dictionary("lan interface")..'</p></td>\n')
end
checked = msg_if.lua_get_user_permissions("at_lan_wlan")
put('      <td><p><input type="radio" name="allow_at_lan_wlan" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
put('      <td><p><input type="radio" name="allow_at_lan_wlan" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
put('    </tr>\n')

if hasBluetooth == TT_TRUE then
    put('    <tr>\n')
    put('      <td><p>'..current_dictionary("bluetooth interface")..'</p></td>\n')
    checked = msg_if.lua_get_user_permissions("at_bluetooth")
    put('      <td><p><input type="radio" name="allow_at_bluetooth" value="1"' .. checked_text(checked) ..'>yes</input></p></td>\n')
    put('      <td><p><input type="radio" name="allow_at_bluetooth" value="0"' .. checked_text(not checked) .. '>no</input></p></td>\n')
    put('    </tr>\n')
else 
   valueString = "0"
   if msg_if.lua_get_user_permissions("at_bluetooth") == true then
       valueString = "1"
   end
   put('<input type="hidden" name="allow_at_bluetooth" value="' .. valueString .. '"></input>')
end


put('    <tr>\n')
put('    <td align="left"><p><INPUT type="submit" value="'..current_dictionary("apply")..'">&nbsp;&nbsp;<INPUT type="reset" value="'..current_dictionary("cancel")..'"></p></td>\n')
put('    </tr>\n')
put('  </tbody>\n')
put('</form>')
put('</TABLE>\n')
put(' \n')



put(end_of_content)
