-- ********************************
-- object handling (set)
-- ********************************

country, channel, broadcast_ssid, ssid, wlan_mode, security_mode, key_mode, key_temp, filter_mode = msg_if.lua_get_wlan_setup()
mac1, mac2, mac3, mac4, mac5, mac6, mac7, mac8, mac9, mac10 = msg_if.lua_get_mac_filters()
key = string.gsub(key_temp,"hex:","")

country_list = {}
no_of_contries = msg_if.lua_get_country_no()
trace(0, 1, string.format("lua - no_of_contries: %d",no_of_contries))
for i = 1,no_of_contries do
    let = msg_if.lua_get_country_letters(i-1)
    table.insert(country_list,let)
end

security_list = {current_dictionary("none"), "WEP-40/64", "WEP-104/128", "WPA-TKIP", "WPA-2-AES"}

if cgilua.cgi["submit1"] ~= nil then
    if cgilua.cgi["country_code"] ~= nil and cgilua.cgi["country_code"] ~= "" then
        country = cgilua.cgi["country_code"]
        msg_if.lua_set_wlan_setup(ssid,country,channel,wlan_mode,security_mode,key_mode,broadcast_ssid,filter_mode,key)
    end
    
end

if cgilua.cgi["submit2"] ~= nil then
    if cgilua.cgi["radio_ssid"] ~= nil then
        if cgilua.cgi["radio_ssid"] == "enabled" then
            broadcast_ssid = 0
        else
            broadcast_ssid = 1
        end
    end

    if cgilua.cgi["radio_mode"] ~= nil then
        if cgilua.cgi["radio_mode"] == "g" then
            wlan_mode = 0
        else
            wlan_mode = 1
        end
    end

    if cgilua.cgi["radio_key"] ~= nil then
        if cgilua.cgi["radio_key"] == "hex" then
            key_mode = 0
        else
            key_mode = 1
        end
    end

    if cgilua.cgi["radio_filter"] ~= nil then
        if cgilua.cgi["radio_filter"] == "enabled" then
            filter_mode = 1
        else
            filter_mode = 0
        end
    end

    if cgilua.cgi["text_ssid"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[text_ssid] = %s",cgilua.cgi["text_ssid"]))
        trace(0, 1, string.format("lua - ssid = %s",ssid))
        ssid = cgilua.cgi["text_ssid"] 
        trace(0, 1, string.format("lua - ssid = %s",ssid))
    end

    if cgilua.cgi["text_key"] ~= nil then
        trace(0, 1, string.format("lua - cgilua.cgi[text_key] = %s",cgilua.cgi["text_key"]))
        trace(0, 1, string.format("lua - key = %s",key))
        key = cgilua.cgi["text_key"] 
        trace(0, 1, string.format("lua - key = %s",key))
    end

    if cgilua.cgi["security_code"] ~= nil then
        trace(0, 1, string.format("lua - security_code: %s",cgilua.cgi["security_code"]))
        security_mode = tonumber(cgilua.cgi["security_code"])
    end

    if cgilua.cgi["channel_list"] ~= nil then
        channel = cgilua.cgi["channel_list"] 
    end

    if cgilua.cgi["text_mac1"] ~= nil then
        mac1 = string.gsub(cgilua.cgi["text_mac1"], ":", "")
        trace(0, 1, string.format("lua - mac1: %s", cgilua.cgi["text_mac1"]))
    end
    if cgilua.cgi["text_mac2"] ~= nil then
        mac2 = string.gsub(cgilua.cgi["text_mac2"], ":", "")
    end
    if cgilua.cgi["text_mac3"] ~= nil then
        mac3 = string.gsub(cgilua.cgi["text_mac3"], ":", "")
    end
    if cgilua.cgi["text_mac4"] ~= nil then
        mac4 = string.gsub(cgilua.cgi["text_mac4"], ":", "")
        trace(0, 1, string.format("lua - mac4: %s", cgilua.cgi["text_mac4"]))
    end
    if cgilua.cgi["text_mac5"] ~= nil then
        mac5 = string.gsub(cgilua.cgi["text_mac5"], ":", "")
    end
    if cgilua.cgi["text_mac6"] ~= nil then
        mac6 = string.gsub(cgilua.cgi["text_mac6"], ":", "")
    end
    if cgilua.cgi["text_mac7"] ~= nil then
        mac7 = string.gsub(cgilua.cgi["text_mac7"], ":", "")
    end
    if cgilua.cgi["text_mac8"] ~= nil then
        mac8 = string.gsub(cgilua.cgi["text_mac8"], ":", "")
    end
    if cgilua.cgi["text_mac9"] ~= nil then
        mac9 = string.gsub(cgilua.cgi["text_mac9"], ":", "")
    end
    if cgilua.cgi["text_mac10"] ~= nil then
        mac10 = string.gsub(cgilua.cgi["text_mac10"], ":", "")
    end

    if key_mode == 0 then
        msg_if.lua_set_wlan_setup(ssid,country,channel,wlan_mode,security_mode,key_mode,broadcast_ssid,filter_mode,'hex:'..key)
    else
        msg_if.lua_set_wlan_setup(ssid,country,channel,wlan_mode,security_mode,key_mode,broadcast_ssid,filter_mode,key)
    end
    msg_if.lua_set_mac_filters(mac1,mac2,mac3,mac4,mac5,mac6,mac7,mac8,mac9,mac10)
end

-- *****************
-- get current state
-- *****************

--country_list = {}
--trace(0, 1, string.format("lua - no_of_contries: %d, country: %d", no_of_contries,country))
--for i = 1,no_of_contries do
--    let = msg_if.lua_get_country_letters(i)
--    table.insert(country_list,let)
--end

--for i = 1,table.getn(country_list) do
--    trace(0, 1, string.format("lua - country_list[%d] = %s",i,country_list[i]))
--end

country, channel, broadcast_ssid, ssid, wlan_mode, security_mode, key_mode, key_temp, filter_mode = msg_if.lua_get_wlan_setup()
key = string.gsub(key_temp,"hex:","")
trace(0, 1, string.format("lua - country = %s",country))
trace(0, 1, string.format("lua - ssid = %s",ssid))

if country == "" then
    error_msg = current_dictionary("please choose a country") 
end

if country ~= "" and hasBluetooth == TT_TRUE then
    bluetooth_country = bt_if.get_bt_country()
    if country == "FR" and bluetooth_country ~= 0 then
        error_msg = current_dictionary("country does not match")
    elseif country ~= "FR" and bluetooth_country == 0 then
        error_msg = current_dictionary("country does not match")
    end
end

mac1, mac2, mac3, mac4, mac5, mac6, mac7, mac8, mac9, mac10 = msg_if.lua_get_mac_filters()

f0, f1, f2, f3, f4, f5, f6, f7, f8, f9, f10, f11, f12, f13, f14, f15, f16, f17, f18, f19, f20, f21, f22, f23, f24, f25, f26, f27, f28, f29, f30, f31, f32, f33, f34, f35, f36, f37, f38, f39, f40, f41, f42, f43, f44, f45, f46, f47, f48, f49, f50 = msg_if.lua_get_wlan_freq(country) 

freq_list = {f0, f1, f2, f3, f4, f5, f6, f7, f8, f9, f10, f11, f12, f13, f14, f15, f16, f17, f18, f19, f20, f21, f22, f23, f24, f25, f26, f27, f28, f29, f30, f31, f32, f33, f34, f35, f36, f37, f38, f39, f40, f41, f42, f43, f44, f45, f46, f47, f48, f49, f50}

-- ***********
-- format html
-- ***********

-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_wlan")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end



put(start_of_content)

js_fs = [[
    <script type="text/javascript">
    function checkWlan(form,to_short,to_long,correct,not_hex,not_supported)
    {
        if (form.radio_key[0].checked == "1" && form.security_code.selectedIndex != 0)
        {
            for (var i = 0;i < form.text_key.value.length; i++)
            {
                switch (form.text_key.value.charAt(i)) {
                case "0":
                case "1":
                case "2":
                case "3":
                case "4":
                case "5":
                case "6":
                case "7":
                case "8":
                case "9":
                case "a":
                case "b":
                case "c":
                case "d":
                case "e":
                case "f":
                case "A":
                case "B":
                case "C":
                case "D":
                case "E":
                case "F":
                    break;
                default:
                    alert(not_hex);
                    form.text_key.focus();
                    return false;
                }
            }
        }
        switch (form.security_code.selectedIndex) {
        case 0:
            return true;  
            break;
        case 1:
            if (form.radio_key[0].checked == "1")
            {
                if (form.text_key.value.length < 10)
                {
                    alert(to_short+correct+"10.");
                    form.text_key.focus();
                    return false;
                }
                else if (form.text_key.value.length > 10)
                {
                    alert(to_long+correct+"10.");
                    form.text_key.focus();
                    return false;    
                }
            }
            else
            {
                alert(not_supported);
                form.text_key.focus();
                return false;   
            }
            break;
        case 2:
            if (form.radio_key[0].checked == "1")
            {
                if (form.text_key.value.length < 26)
                {
                    alert(to_short+correct+"26.");
                    form.text_key.focus();
                    return false;
                }
                else if (form.text_key.value.length > 26)
                {
                    alert(to_long+correct+"26.");
                    form.text_key.focus();
                    return false;    
                }
            }
            else
            {
                alert(not_supported);
                form.text_key.focus();
                return false;   
            }   
            break;
        case 3:
            if (form.radio_key[0].checked == "1")
            {
                if (form.text_key.value.length < 64)
                {
                    alert(to_short+correct+"64.");
                    form.text_key.focus();
                    return false;
                }
                else if (form.text_key.value.length > 64)
                {
                    alert(to_long+correct+"64.");
                    form.text_key.focus();
                    return false;    
                }
            }
            else
            {
                if (form.text_key.value.length < 6)
                {
                    alert(to_short);
                    form.text_key.focus();
                    return false;
                }
            }
            break;
        case 4:
            if (form.radio_key[0].checked == "1")
            {
                if (form.text_key.value.length < 64)
                {
                    alert(to_short+correct+"64.");
                    form.text_key.focus();
                    return false;
                }
                else if (form.text_key.value.length > 64)
                {
                    alert(to_long+correct+"64.");
                    form.text_key.focus();
                    return false;    
                }
            }
            else
            {
                if (form.text_key.value.length < 6)
                {
                    alert(to_short);
                    form.text_key.focus();
                    return false;
                }
            }
            break;
        }
        return true;
    }
    </script>
    ]]
put(js_fs)

to_long = current_dictionary("to long")
to_short = current_dictionary("to short")
correct_length = current_dictionary("correct")
not_hex = current_dictionary("not hex")
not_supported = current_dictionary("not supported")
submit_text = 'onsubmit=\'return checkWlan(this,"'..to_short..'","'..to_long..'","'..correct_length..'","'..not_hex..'","'..not_supported..'");\''

--submit_text = 'return checkWlan(this,"to short","to long");'

put('<p id="errortext">' .. error_msg .. '</p>')

put('<p><table border="'..border_on..'" cellpadding="0" align="left" valign="top">')
    put('<form name="settings_interfaces" method="post" ' .. submit_text .. ' action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')
    --Enable/disable interface
    put('<tr>')
        put('<th align="left"><p class="menutext">' ..current_dictionary("interface status").. '</p></th>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("wlan interface") .. '</p></td>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_onoff_wlan" value="enabled" ' ..checked_text(status == 0).. '>' .. current_dictionary("enabled") .. '\n')
        put('<input ' .. disabled_string .. ' type="radio" name="radio_onoff_wlan" value="disabled" ' ..checked_text(status == 1).. '>' .. current_dictionary("disabled") .. '</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("country") .. '</p></td>')
        put('<td align="left" colspan="2"><select ' .. disabled_string .. '  size="5" name="country_code">')
        for i = 1,table.getn(country_list) do
            put('<option ' ..selected_text(country == country_list[i]).. '>' .. country_list[i] .. '</option>\n')
        end
        put('</select></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="submit" name="submit1" value="' .. current_dictionary("apply") .. '">')
        put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left" colspan="3"><hr></td>\n')
    put('</tr>')
    if country ~= "" then
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("channel") .. '</p></td>')
            put('<td align="left" colspan="2"><select ' .. disabled_string .. '  size="5" name="channel_list">')
            put('<option ' ..selected_text((channel) == freq_list[1]).. '>' .. freq_list[1] .. '</option>\n')
            for i = 2,table.getn(freq_list) do
                if freq_list[i] ~= 0 and freq_list[i] ~= nil then 
                    put('<option ' ..selected_text((channel) == freq_list[i]).. '>' .. freq_list[i] .. '</option>\n')
                end
            end
        put('</select></td>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("broadcast ssid") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_ssid" value="enabled" ' ..checked_text(broadcast_ssid == 0).. '>' .. current_dictionary("enabled") .. '\n')
            put('<input ' .. disabled_string .. ' type="radio" name="radio_ssid" value="disabled" ' ..checked_text(broadcast_ssid == 1).. '>' .. current_dictionary("disabled") .. '</p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("ssid") .. '</p></td>')
            put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" maxlength="32" name="text_ssid" value="' .. ssid .. '" size="18"></p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("wlan mode") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_mode" value="a" ' ..checked_text(wlan_mode == 1).. '>802.11a\n')
            put('<input ' .. disabled_string .. ' type="radio" name="radio_mode" value="g" ' ..checked_text(wlan_mode == 0).. '>802.11b/g</p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("security") .. '</p></td>')
            put('<td align="left" colspan="2"><select ' .. disabled_string .. '  size="5" name="security_code">')
            for i = 1,table.getn(security_list) do
                put('<option value="'.. i-1 ..'" ' ..selected_text((security_mode) == i-1).. '>' .. security_list[i] .. '</option>\n')
            end
            put('</select></td>')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("key type") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_key" value="hex" ' ..checked_text(key_mode == 0).. '>' .. current_dictionary("hexadecimal") ..'\n')
            put('<input ' .. disabled_string .. ' type="radio" name="radio_key" value="string" ' ..checked_text(key_mode == 1).. '>' .. current_dictionary("text") ..'</p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' .. current_dictionary("encryption key") .. '</p></td>')
            put('<td align="left" colspan="2"><p><input ' .. disabled_string .. ' type="text" maxlength="77" name="text_key" size="12" value="' .. key .. '"></p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("mac address filter") .. '</p></td>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="radio" name="radio_filter" value="enabled" ' ..checked_text(filter_mode == 1).. '>' .. current_dictionary("enabled") .. '\n')
            put('<input ' .. disabled_string .. ' type="radio" name="radio_filter" value="disabled" ' ..checked_text(filter_mode == 0).. '>' .. current_dictionary("disabled") .. '</p></td>\n')
        put('</tr>')
        
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("allowed mac address") ..'</p></td>')
            put('<td align="left" width="400"><p>')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac1 ..'" maxlength="17" name="text_mac1" size="21">&nbsp;')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac2 ..'" maxlength="17" name="text_mac2" size="21">')
            put('</p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p></p></td>')
            put('<td align="left" width="400"><p>')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac3 ..'" maxlength="17" name="text_mac3" size="21">&nbsp;')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac4 ..'" maxlength="17" name="text_mac4" size="21">')
            put('</p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p></p></td>')
            put('<td align="left" width="400"><p>')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac5 ..'" maxlength="17" name="text_mac5" size="21">&nbsp;')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac6 ..'" maxlength="17" name="text_mac6" size="21">')
            put('</p></td>\n')
        put('</tr>')
        put('<tr>')
            put('<td align="left"><p></p></td>')
            put('<td align="left" width="400"><p>')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac7 ..'" maxlength="17" name="text_mac7" size="21">&nbsp;')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac8 ..'" maxlength="17" name="text_mac8" size="21">')
            put('</p></td>\n')
        put('</tr>')        
        put('<tr>')
            put('<td align="left"><p></p></td>')
            put('<td align="left" width="400"><p>')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac9 ..'" maxlength="17" name="text_mac9" size="21">&nbsp;')
            put('<input ' .. disabled_string .. ' type="text" value="'.. mac10 ..'" maxlength="17" name="text_mac10" size="21">')
            put('</p></td>\n')
        put('</tr>')        
        --submit button
        put('<tr>')
            put('<td align="left"><p><input ' .. disabled_string .. ' type="submit" name="submit2" value="' .. current_dictionary("apply") .. '">')
            put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
        put('</tr>')
    end
put('</form></table></p>\n')
put(end_of_content)
