module (arg and arg[1])

local function debug_info (req, res, params)
        -- wrap res_send_data so it can be given as a parameter to
        -- the shell below
        local function output(data)
            res:send_data(data)
        end

	if req.cmd_mth ~= "GET" then
		return httpd.err_405 (req, res)
	end

	params = params or {}
	
	res.headers ["Content-Type"] = "application/octet-stream"

        for i, v in pairs(params) do
            shell.shell(v, output)
        end
	
	return res
end


function makeHandler (params)
	return function (req, res)
		return debug_info (req, res, params)
	end
end
