module (arg and arg[1])


local function export_config (req, res, params)

    res.headers ["Content-Type"] = "application/octet-stream"

    max_config= msg_if.lua_read_config_init()
    if max_config > 0 then
        for i=0,max_config do
            len, header, output = msg_if.lua_read_config(i)
            if (len > 0) then
                res:send_data(header)
                res:send_data(output)
            end
        end
    end
    if max_config >= 0 then
        msg_if.lua_read_config_rel()
    end
    return res
end


function makeHandler (params)
    return function (req, res)
        return export_config (req, res, params)
    end
end 

