if cgilua.cgi["gps_ant"] ~= nil then
    trace(0, 1, string.format("lua - GPS antenna: %s",cgilua.cgi["gps_ant"]))
    if cgilua.cgi["gps_ant"] == "Auto" then
        msg_if.lua_set_gps_antenna(2)
    end
    if cgilua.cgi["gps_ant"] == "GPS" then
        msg_if.lua_set_gps_antenna(1)
    end
    if cgilua.cgi["gps_ant"] == "I-4" then
        msg_if.lua_set_gps_antenna(0)
    end
end

gps_antenna = msg_if.lua_get_gps_antenna()


-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_general")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end

put(start_of_content)
--Print any error message
put('<p id="errortext">' .. error_msg .. '</p>')
put('<form name="advanced_settings" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')
put('<p><table align=left border="'..border_on..'" cellpadding="0">')
put('<tr>')
    put('<th align="left"><p class="menutext">' ..current_dictionary("gps antenna selection").. '</p></th>')
put('</tr>')
put('<tr>')
    put('<td align="left" colspan="4"><p>' ..current_dictionary("gps antenna")..'&nbsp;')
        put('<input ' .. disabled_string .. ' type="radio" name="gps_ant" value="Auto"' .. checked_text(gps_antenna == 2) .. '>'  .. current_dictionary("auto") .. '</input>\n')
        put('<input ' .. disabled_string .. ' type="radio" name="gps_ant" value="GPS"' .. checked_text(gps_antenna == 1) .. '>' .. current_dictionary("gps") .. '</input>')
        put('<input ' .. disabled_string .. ' type="radio" name="gps_ant" value="I-4"' .. checked_text(gps_antenna == 0) .. '>'  .. current_dictionary("i-4") .. '</input></p>\n')
    put('</td>')
put('</tr>')       
put('<tr>')
    put('<td align="left"><p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
    put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
put('</tr>')
put('</table></p>\n')
put('</form>\n')
put(end_of_content)

