error_msg = ""
debug_msg = ""

show_list_header = function()
    put('<tr>')
    put('<th align="left" width="35%"><p>'..current_dictionary("alarm first reported")..'</p></th>')
    put('<th align="center" width="10%"><p>'..current_dictionary("alarm id")..'</p></th>')
    put('<th align="center" width="10%"><p>'..current_dictionary("alarm severity")..'</p></th>')
    put('<th align="center" width="10%"><p>'..current_dictionary("alarm count")..'</p></th>')
    put('<th align="left" width="35%"><p>'..current_dictionary("alarm text")..'</p></th>')
    put('</tr>')
end


show_log_entry = function(timeStr, IDStr, severityStr, countStr, textStr)
--Then print log entry
    put('<tr>')
    put('<td align="left"><p>' ..translate_month_and_1970(timeStr).. '</p></td>') 
    put('<td align="center"><p>' ..IDStr.. '</p></td>')
    put('<td align="center"><p>' ..severityStr.. '</p></td>')
    put('<td align="center"><p>' ..countStr.. '</p></td>')
    put('<td align="left"><p>' ..textStr.. '</p></td>')
    put('</tr>')
end

idx = 0;
timeStr, IDStr, severityStr, unitStr, countStr, textStr, listNotEmpty = msg_if.lua_get_first_event_entry(idx, string.lower(lang), true)

-- Generate the HTML
put(start_of_content)
--Print any error message
put('<table align="center"><tr><td><p id="errortext">')
put(error_msg .. '</p></td></tr></table>')
--debug put('<table align="center"><tr><td><p>')
--debug put(debug_msg .. '</p></td></tr></table>')

put('<p id="alm_lst_tab"><table align="left" border="'..border_on..'" cellpadding="1" width="75%">')
put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. ' ">')

if listNotEmpty then
    
    show_list_header()

    while listNotEmpty do
        show_log_entry(timeStr, IDStr, severityStr, countStr, textStr)
        idx = idx +1 -- get next alarm
        timeStr, IDStr, severityStr, unitStr, countStr, textStr, listNotEmpty = msg_if.lua_get_next_event_entry(idx, string.lower(lang), true)
    end 
    
else
    put('<th align="left" width="20%"><p>' .. current_dictionary("alarm list empty") .. '</p></th>')
end
put('</form>')
put('</table></p>')

put(end_of_content)

