js_timer_func = [[
<script type="text/javascript">
function local_timer_func()
{
    document.call_setting.submit();
}
function local_onload_func()
{
    timer=setTimeout('local_timer_func()',5000);
}
</script>
]]
js_timer_func2 = [[
<script type="text/javascript">
function local_onload_func()
{
}
</script>
]]

disabled_text = function (expr)
  if (expr) then
    return ' disabled '
  else
    return ''
  end
end

show_section = function (prefix, out_enab,exhc_enab,in_enab,roam_enab)
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_out_enab_hidden" value="'..out_enab..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_exhc_enab_hidden" value="'..exhc_enab..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_in_enab_hidden" value="'..in_enab..'">')
    put('<input ' .. disabled_string .. ' type="hidden" name="'..prefix..'_roam_enab_hidden" value="'..roam_enab..'">')
    
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_out_enab" value="on" '..checked_text(out_enab == 1)..'>&nbsp;' ..current_dictionary("barr all out")..'</p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_exhc_enab" value="on" '..checked_text(exhc_enab == 1)..'>&nbsp;' ..current_dictionary("barr out except hc")..'</p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_in_enab"  value="on" '..checked_text(in_enab == 1)..'>&nbsp;' ..current_dictionary("barr all in")..'</p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input ' .. disabled_string .. ' type="checkbox" name="'..prefix..'_roam_enab" value="on" '..checked_text(roam_enab == 1)..'>&nbsp;' ..current_dictionary("barr roam")..'</p></td>')
    put('</tr>')
end

handle_post_values = function(arg)
    if_class = 1
    if arg == "speech" then
        if_class = 1
    elseif arg == "audio" then
        if_class = 4
    elseif arg == "data" then
        if_class = 2
    end

    -- barr all out
    if cgilua.cgi[arg.."_out_enab"] ~= nil then
        if cgilua.cgi[arg.."_out_enab"] == "on" then
            vals[arg..'_out_enab'] = 1
        else
            vals[arg..'_out_enab'] = 0
        end        
    end

    if cgilua.cgi[arg..'_out_enab_hidden'] ~= nil then
        if vals[arg..'_out_enab'] ~= tonumber(cgilua.cgi[arg..'_out_enab_hidden']) then
            ss_if.change_barr(1,if_class,vals[arg..'_out_enab'],cgilua.cgi["barr_pin"])
        end
    end

    -- barr out except hc
    if cgilua.cgi[arg.."_exhc_enab"] ~= nil then
        if cgilua.cgi[arg.."_exhc_enab"] == "on" then
            vals[arg..'_exhc_enab'] = 1
        else
            vals[arg..'_exhc_enab'] = 0
        end        
    end

    if cgilua.cgi[arg..'_exhc_enab_hidden'] ~= nil then
        if vals[arg..'_exhc_enab'] ~= tonumber(cgilua.cgi[arg..'_exhc_enab_hidden']) then
            ss_if.change_barr(2,if_class,vals[arg..'_exhc_enab'],cgilua.cgi["barr_pin"])
        end
    end

    -- barr all in
    if cgilua.cgi[arg.."_in_enab"] ~= nil then
        if cgilua.cgi[arg.."_in_enab"] == "on" then
            vals[arg..'_in_enab'] = 1
        else
            vals[arg..'_in_enab'] = 0
        end        
    end
    if cgilua.cgi[arg..'_in_enab_hidden'] ~= nil then
        if vals[arg..'_in_enab'] ~= tonumber(cgilua.cgi[arg..'_in_enab_hidden']) then
            ss_if.change_barr(3,if_class,vals[arg..'_in_enab'],cgilua.cgi["barr_pin"])
        end
    end

    -- barr incoming roam
    if cgilua.cgi[arg.."_roam_enab"] ~= nil then
        if cgilua.cgi[arg.."_roam_enab"] == "on" then
            vals[arg..'_roam_enab'] = 1
        else
            vals[arg..'_roam_enab'] = 0
        end        
    end
    if cgilua.cgi[arg..'_roam_enab_hidden'] ~= nil then
        if vals[arg..'_roam_enab'] ~= tonumber(cgilua.cgi[arg..'_roam_enab_hidden']) then
            ss_if.change_barr(4,if_class,vals[arg..'_roam_enab'],cgilua.cgi["barr_pin"])
        end
    end
end

init_with_hidden_values = function(arg)
    -- barr all out
    if cgilua.cgi[arg.."_out_enab_hidden"] ~= nil then
        vals[arg..'_out_enab'] = tonumber(cgilua.cgi[arg.."_out_enab_hidden"])
    end

    -- barr out except hc
    if cgilua.cgi[arg.."_exhc_enab_hidden"] ~= nil then
        vals[arg..'_exhc_enab'] = tonumber(cgilua.cgi[arg.."_exhc_enab_hidden"])
    end

    -- barr all in
    if cgilua.cgi[arg.."_in_enab_hidden"] ~= nil then
        vals[arg..'_in_enab'] = tonumber(cgilua.cgi[arg.."_in_enab_hidden"])
    end

    -- barr incoming roam
    if cgilua.cgi[arg.."_roam_enab_hidden"] ~= nil then
        vals[arg..'_roam_enab'] = tonumber(cgilua.cgi[arg.."_roam_enab_hidden"])
    end
end

function check_barr_pin (number)
    _, ok_chars = string.gsub(number, "[%d]", "")
    --put(ok_chars)
    if ok_chars < string.len(number) or ok_chars ~= 4 then
        return false
    else
        return true
    end
end

-- Setup initial values
vals = {}
vals["speech_out_enab"] = 0
vals["speech_exhc_enab"] = 0
vals["speech_in_enab"] = 0
vals["speech_roam_enab"] = 0

vals["audio_out_enab"] = 0
vals["audio_exhc_enab"] = 0
vals["audio_in_enab"] = 0
vals["audio_roam_enab"] = 0

vals["data_out_enab"] = 0
vals["data_exhc_enab"] = 0
vals["data_in_enab"] = 0
vals["data_roam_enab"] = 0

if cgilua.cgi["barr_query"] ~= nil then
    ss_if.query_barr_status(1)
    ss_if.query_barr_status(2)
    ss_if.query_barr_status(3)
    ss_if.query_barr_status(4)
    
elseif cgilua.cgi["barr_apply"] ~= nil then
    -- Parse incomming parameters
    barr_pin_accepted = true
    if cgilua.cgi["barr_pin"] ~= nil then
        if not check_barr_pin(cgilua.cgi["barr_pin"]) then
            error_msg = current_dictionary("please enter barring pin")
            barr_pin_accepted = false
        end
    else
        error_msg = current_dictionary("please enter barring pin")
        barr_pin_accepted = false
    end
    if barr_pin_accepted then
        handle_post_values("speech")
        handle_post_values("audio")
        handle_post_values("data")
    end
else
    init_with_hidden_values("speech")
    init_with_hidden_values("audio")
    init_with_hidden_values("data")
end    

if cgilua.cgi["barr_query"] ~= nil then 
    trace(0,1,"barr_query")
end
if cgilua.cgi["barr_apply"] ~= nil then 
    trace(0,1,"barr_apply")
end


wait = false
if ss_if.is_operation_in_progress() then
    error_msg = current_dictionary("operation in progress")
    wait = true
end

number_barr_records = 0
if wait == false then
    -- If hidden values exist (not first time we show the page), show warning if last operation might have failed.
    if cgilua.cgi["speech_out_enab_hidden"] ~= nil then
        barr_res, number_barr_records = ss_if.get_last_barr_operation_result()
        if not barr_res then
            if cgilua.cgi["barrop"] == "query" then
                error_msg = current_dictionary("barr query failed")
            elseif cgilua.cgi["barrop"] == "set" then
                error_msg = current_dictionary("barr set failed") 
            end
        end
        if barr_res then
            trace(0,1, string.format("Barr result ok"))
        else
            trace(0,1, string.format("Barr result fail"))
        end
        if barr_res == nil then
            trace(0,1, string.format("Barr result NIL"))
        end

        -- get values from ss_if first time after query is done
        if cgilua.cgi["barrop"] == "query" then
            if number_barr_records ~= nil then
                trace(0,1, string.format("records %d",number_barr_records))
            else
                trace(0,1, string.format("records nil"))
            end
        
            if number_barr_records > 0 then
                for i=1,number_barr_records do
                    barr_class, barr_ss_type = ss_if.get_barr_entry(i-1)
                    trace(0, 1, string.format("idx %d barr class %d type %d",i,barr_class,barr_ss_type))

                    class_txt = nil
                    if barr_class == 1 then
                        class_txt = "speech"
                    elseif barr_class == 2 then
                        class_txt = "data"
                    elseif barr_class == 4 then
                        class_txt = "audio"
                    end

                    type_txt = nil
                    if barr_ss_type == 1 then
                        type_txt = "_out"
                    elseif barr_ss_type == 2 then
                        type_txt = "_exhc"
                    elseif barr_ss_type == 3 then
                        type_txt = "_in"
                    elseif barr_ss_type == 4 then
                        type_txt = "_roam"
                    end

                    if class_txt ~= nil and type_txt ~= nil then
                        vals[class_txt..type_txt.."_enab"] = 1
                    else
                        trace(0,1,string.format("Invalid class or type in response"))
                    end
                end
            end
        end
    else
        if not msg_if.lua_is_ready_for_ss() then
            error_msg = current_dictionary("ss reg needed")
        end
    end
end

if cgilua.cgi["local_onload"] ~= nil then
    trace(0,1,"cf onload")
end


-- check access permission
    disabled_string = ''
    if admin_status < 0 then
        allowed = msg_if.lua_get_user_permissions("change_supplementary")
        if not allowed then 
            disabled_string = ' disabled '
            error_msg = current_dictionary("admin_locked")
        end
    end


put(start_of_content)

put('<p id="errortext">' .. error_msg .. '</p>')

if wait then
    put(js_timer_func)
elseif cgilua.cgi["local_onload"] ~= nil then
    put(js_timer_func2)
end

put('<p><table align="left" border="'..border_on..'" cellpadding="0">\n')
put('<form name="call_setting" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
--put('<tr><td colspan="4"><p id="errortext">'..error_msg..'</p></td></tr>')
put('<tr><td align="left"><p>'..current_dictionary("read values")..'&nbsp;&nbsp;<input ' .. disabled_string .. ' type="submit" name="barr_query" value="'..current_dictionary("read button")..'" '..disabled_text(wait)..'></p></td>')
put('<tr><td>&nbsp;</td></tr>')
if cgilua.cgi["barr_query"] ~= nil then
    put('<input ' .. disabled_string .. ' type="hidden" name="barrop" value="query">')
elseif cgilua.cgi["barr_apply"] ~= nil then
    put('<input ' .. disabled_string .. ' type="hidden" name="barrop" value="set">')
elseif wait and cgilua.cgi["barrop"] ~= nil then
    put('<input ' .. disabled_string .. ' type="hidden" name="barrop" value="'..cgilua.cgi["barrop"]..'">')
end
if wait then
    put('<input ' .. disabled_string .. ' type="hidden" name="local_onload" value="">')
end

put('<tr>')
    put('<th align="left" colspan="2"><p class="menutext">' ..current_dictionary("standard voice").. '</p></th>')
put('</tr>')

show_section("speech",vals["speech_out_enab"],vals["speech_exhc_enab"],vals["speech_in_enab"],vals["speech_roam_enab"])

put('<tr>')
    put('<th align="left"><p class="menutext">' ..current_dictionary("3.1kHz audio").. '</p></th>')
put('</tr>')

show_section("audio",vals["audio_out_enab"],vals["audio_exhc_enab"],vals["audio_in_enab"],vals["audio_roam_enab"])

put('<tr>')
    if hasISDN == TT_TRUE then
        put('<th align="left"><p class="menutext">' ..current_dictionary("data isdn").. '</p></th>')
    else
        put('<th align="left"><p class="menutext">' ..current_dictionary("data").. '</p></th>')
    end
put('</tr>')

show_section("data",vals["data_out_enab"],vals["data_exhc_enab"],vals["data_in_enab"],vals["data_roam_enab"])

put('<tr>')
put('<td align="left"><p>'..current_dictionary("barr pin")..'&nbsp;<input ' .. disabled_string .. ' type="password" name="barr_pin" maxlength="4" size="4" </p></td>')
put('</tr>')

put('<tr>')
put('<td align="left"><p><input ' .. disabled_string .. ' type="submit" value="'..current_dictionary("apply")..'" name="barr_apply" '..disabled_text(wait)..'>&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="reset" value="'..current_dictionary("cancel")..'" name="reset" '..disabled_text(wait)..'></p></td>')
put('</tr>')
put('<tr><td>&nbsp;</td></tr>')
put('<tr>')
    put('<td align="left" colspan="3">')
        put('<p>' ..current_dictionary("ss info").. '</p>')
    put('</td>')
put('</tr>')


put('</form>\n') 
put('</table></p>\n')
put(end_of_content)

