if cgilua.cgi["Export"] ~= nil then
    if cgilua.cgi["Export"] == "Export" then
       put('<meta http-equiv="REFRESH" content="0; url=call_log.txt">')
    end    
end

time_format = function(duration)
    h = 0
    m = 0
    s = 0
    d = 0
    s  = math.mod(duration, 60)
    m  = (math.mod(duration, 3600) - s)/60
    h = math.mod((duration - m*60 - s)/3600,24)
    d = (duration - h*3600 - m*60 - s)/(3600*24)
    if d > 0 then
        timestr = string.format("%dd %02d:%02d:%02d", d, h, m, s)
    else
        timestr = string.format("%02d:%02d:%02d", h, m, s)
    end
    return timestr  
end

error_msg = ""
debug_msg = ""

phone_fax_mins, khz_31_audio_mins = call_log_if.get_total_call_usage()

-- Generate the HTML
put(start_of_content)
--Print any error message
put('<table align="center"><tr><td><p id="errortext">')
put(error_msg .. '</p></td></tr></table>')
    put('<p id="calls_table"><table align="left" border="'..border_on..'" cellpadding="6" width="70%">')    
    put('<tr>')
        put('<th align="left" width="60%"><p class="menutext">' ..current_dictionary("total usage").. '</p></th>')
    put('</tr>\n')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("standard voice")..': '..time_format(phone_fax_mins)..  '</p></td>')
    put('</tr>\n')
    if CS_SUPPORT ~= "CS_STANDARD" then
        put('<tr>')
            put('<td align="left"><p>' ..current_dictionary("3.1kHz audio")..': '..time_format(khz_31_audio_mins)..  '</p></td>')
            put('<td align="left"><p>&nbsp;</p></td>')
        put('</tr>\n')
    end
    put('<tr><td>&nbsp;</td></tr>');
    put('<tr>')
        put('<td><p>');
        link_generate (page_title, "&amp;Export=Export", "export call log to file", "norm")
        put('</p></td>');
    put('</tr>');

    put('</table></p>')

put(end_of_content)

