--parse input
if cgilua.cgi['discreteioOP'] == 'update' then

    enabled_set = {}
    if (cgilua.cgi['ringer_enabled'] == 'ON') then
	enabled_set[0] = true
    else
	enabled_set[0] = false
    end
    if (cgilua.cgi['warning_enabled'] == 'ON') then
	enabled_set[1] = true
    else
	enabled_set[1] = false
    end
    if (cgilua.cgi['mute_enabled'] == 'ON') then
	enabled_set[2] = true
    else
	enabled_set[2] = false
    end
    if (cgilua.cgi['radiosilence_enabled'] == 'ON') then
	enabled_set[3] = true
    else
	enabled_set[3] = false
    end
    if (cgilua.cgi['ignition_enabled'] == 'ON') then
	enabled_set[4] = true
    else
	enabled_set[4] = false
    end

    inputActiveHigh_set = {}
    for i=0,4 do
	inputActiveHigh_set[i] = false
    end

    outputActiveHigh_set = {}
    for i=0,4 do
	outputActiveHigh_set[i] = false
    end

    if (cgilua.cgi['pol_ringer'] == 'high') then
	outputActiveHigh_set[0] = true
    elseif (cgilua.cgi['pol_ringer'] == 'low') then
	outputActiveHigh_set[0] = false
    end
    if (cgilua.cgi['pol_warning'] == 'high') then
	outputActiveHigh_set[1] = true
    elseif (cgilua.cgi['pol_warning'] == 'low') then
	outputActiveHigh_set[1] = false
    end
    if (cgilua.cgi['pol_mute'] == 'high') then
	outputActiveHigh_set[2] = true
    elseif (cgilua.cgi['pol_mute'] == 'low') then
	outputActiveHigh_set[2] = false
    end
    if (cgilua.cgi['pol_radiosilence'] == 'high') then
	inputActiveHigh_set[3] = true
    elseif (cgilua.cgi['pol_radiosilence'] == 'low') then
	inputActiveHigh_set[3] = false
    end
    if (cgilua.cgi['pol_ignition'] == 'high') then
	inputActiveHigh_set[4] = true
    elseif (cgilua.cgi['pol_ignition'] == 'low') then
	inputActiveHigh_set[4] = false
    end

    ringerCallType_set = {}
    for i=0,3 do
	ringerCallType_set[i] = false
    end

    if (cgilua.cgi['std_ringer'] == 'ON') then
	ringerCallType_set[0] = true
    else
	ringerCallType_set[0] = false
    end
    if (cgilua.cgi['prem_ringer'] == 'ON') then
	ringerCallType_set[1] = true
    else
	ringerCallType_set[1] = false
    end
    if (cgilua.cgi['udi_ringer'] == 'ON') then
	ringerCallType_set[2] = true
    else
	ringerCallType_set[2] = false
    end
    if (cgilua.cgi['rdi_ringer'] == 'ON') then
	ringerCallType_set[3] = true
    else
	ringerCallType_set[3] = false
    end

    muteCallType_set = {}
    for i=0,3 do
	muteCallType_set[i] = false
    end

    if (cgilua.cgi['std_mute'] == 'ON') then
	muteCallType_set[0] = true
    else
	muteCallType_set[0] = false
    end
    if (cgilua.cgi['prem_mute'] == 'ON') then
	muteCallType_set[1] = true
    else
	muteCallType_set[1] = false
    end
    if (cgilua.cgi['udi_mute'] == 'ON') then
	muteCallType_set[2] = true
    else
	muteCallType_set[2] = false
    end
    if (cgilua.cgi['rdi_mute'] == 'ON') then
	muteCallType_set[3] = true
    else
	muteCallType_set[3] = false
    end

    delayShutdownTimer_set = cgilua.cgi['delay']

    msg_if.lua_set_discreteio_status(delayShutdownTimer_set,
				     muteCallType_set,
				     ringerCallType_set,
				     outputActiveHigh_set,
				     inputActiveHigh_set,
				     enabled_set);

end

-- check access permission
disabled_string = ''
allowed = true
if admin_status < 0 then
    allowed = msg_if.lua_get_user_permissions("change_discrete_io")
    if not allowed then 
        disabled_string = ' disabled '
        error_msg = current_dictionary("admin_locked")
    end
end

enabled, inputActiveHigh, outputActiveHigh, ringerCallType, muteCallType, delayShutdownTimer = msg_if.lua_read_discreteio_status()

put(start_of_content)

put('<p id="errortext">' .. error_msg .. '</p>\n')
put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;discreteioOP=update">\n')

-- Discrete I/O
put('<table align="left" border="' .. border_on ..'" cellpadding="0">\n')
put('<tr>')
put('<td colspan="5" align="left"><p class="menutext">' .. current_dictionary('discrete io') .. '</p></td>')
put('</tr>\n')
put('<tr>')
put('<th align="center"><p>' .. current_dictionary('discreteiopin') .. '</p></th>')
put('<th align="left"><p>' .. current_dictionary('io') .. '</p></th>')
put('<th align="left"><p>&nbsp;&nbsp;' .. current_dictionary('function') .. '</p></th>')
put('<th align="left"><p>' .. current_dictionary('enabled') .. '</p></th>')
put('<th align="left"><p>&nbsp;&nbsp;' .. current_dictionary('polarity') .. '</p></th>')
put('</tr>\n')
put('<tr>')
put('<td><p align="center">1</p></td>')
put('<td><p align="left">' .. current_dictionary('output') .. '</p></td>')
put('<td><p align="left">&nbsp;&nbsp;' .. current_dictionary('ringer') .. '</p></td>')
put('<td align="center"><p><input ' .. disabled_string .. ' type="checkbox" name="ringer_enabled"')
    put(checked_text(enabled[0]) ..' value="ON"></p></td>')
put('<td><p>&nbsp;&nbsp;<input ' .. disabled_string .. ' type="radio" name="pol_ringer" value="high"')
    put(checked_text(outputActiveHigh[0])..'>' .. current_dictionary('active high') .. ' <input ' .. disabled_string .. ' type="radio" name="pol_ringer" value="low"')
    put(checked_text(not outputActiveHigh[0]) ..'>' .. current_dictionary('active low') .. '</p></td>')
put('</tr>\n')
put('<tr>')
put('<td><p align="center">2</p></td>')
put('<td><p align="left">' .. current_dictionary('output') .. '</p></td>')
put('<td><p align="left">&nbsp;&nbsp;' .. current_dictionary('warning') .. '</p></td>')
put('<td align="center"><p><input ' .. disabled_string .. ' type="checkbox" name="warning_enabled"')
    put(checked_text(enabled[1])..' value="ON"></p></td>')
put('<td><p>&nbsp;&nbsp;<input ' .. disabled_string .. ' type="radio" name="pol_warning" value="high"')
    put(checked_text(outputActiveHigh[1])..'>' .. current_dictionary('active high') .. ' <input ' .. disabled_string .. ' type="radio" name="pol_warning" value="low"')
    put(checked_text(not outputActiveHigh[1])..'>' .. current_dictionary('active low') .. '</p></td>')
put('</tr>\n')
put('<tr>')
put('<td><p align="center">3</p></td>')
put('<td><p align="left">' .. current_dictionary('output') .. '</p></td>')
put('<td><p align="left">&nbsp;&nbsp;' .. current_dictionary('mute') .. '</p></td>')
put('<td align="center"><p><input ' .. disabled_string .. ' type="checkbox" name="mute_enabled"')
    put(checked_text(enabled[2])..' value="ON"></p></td>')
put('<td><p>&nbsp;&nbsp;<input ' .. disabled_string .. ' type="radio" name="pol_mute" value="high"')
    put(checked_text(outputActiveHigh[2])..'>' .. current_dictionary('active high') .. ' <input ' .. disabled_string .. ' type="radio" name="pol_mute" value="low"')
    put(checked_text(not outputActiveHigh[2])..'>' .. current_dictionary('active low') .. '</p></td>')
put('</tr>\n')
put('<tr>')
put('<td><p align="center">4</p></td>')
put('<td><p align="left">' .. current_dictionary('input') .. '</p></td>')
put('<td><p align="left">&nbsp;&nbsp;' .. current_dictionary('radio silence') .. '</p></td>')
put('<td align="center"><p><input ' .. disabled_string .. ' type="checkbox" name="radiosilence_enabled"')
    put(checked_text(enabled[3])..' value="ON"></p></td>')
put('<td><p>&nbsp;&nbsp;<input ' .. disabled_string .. ' type="radio" name="pol_radiosilence" value="high"')
    put(checked_text(inputActiveHigh[3])..'>' .. current_dictionary('active high') .. ' <input ' .. disabled_string .. ' type="radio" name="pol_radiosilence" value="low"')
    put(checked_text(not inputActiveHigh[3])..'>' .. current_dictionary('active low') .. '</p></td>')
put('</tr>\n')
put('<tr>')
put('<td><p align="center">5</p></td>')
put('<td><p align="left">' .. current_dictionary('input') .. '</p></td>')
put('<td><p align="left">&nbsp;&nbsp;' .. current_dictionary('ignition') .. '</p></td>')
put('<td align="center"><p><input ' .. disabled_string .. ' type="checkbox" name="ignition_enabled"')
    put(checked_text(enabled[4])..' value="ON"></p></td>')
put('<td><p>&nbsp;&nbsp;<input ' .. disabled_string .. ' type="radio" name="pol_ignition" value="high"')
    put(checked_text(inputActiveHigh[4]).. '>' .. current_dictionary('active high') .. ' <input ' .. disabled_string .. ' type="radio" name="pol_ignition" value="low"')
    put(checked_text(not inputActiveHigh[4]).. '>' .. current_dictionary('active low') .. '</p></td>')
put('</tr>\n')
put('<tr><td>&nbsp</td></tr>')

-- Delayed Shutdown
put('<tr><th align="left" colspan="5"><p class="menutext">' .. current_dictionary('delayed shutdown') .. '</p></th></tr>\n')
put('<tr><td align="left"><p>' .. current_dictionary('delay') .. '&nbsp;&nbsp;</p></td>');
put('<td align="left" colspan="4"><p><select ' .. disabled_string .. ' name="delay">')
for i=0,15 do
    if (i == delayShutdownTimer) then
	put('<option selected="selected">' .. i .. '</option>')
    else
	put('<option>' .. i .. '</option>')
    end
end
put('</select>&nbsp (' .. current_dictionary('minutes') .. ')</p></td></tr>\n')
put('<tr><td>&nbsp</td></tr>')

-- Ringer Output
put('<tr><th align="left" colspan="5"><p class="menutext">' .. current_dictionary('ringer output') .. '</p></th></tr>')
put('<tr>')
put('<td align="left" ><p>' ..current_dictionary("incoming calls").. '&nbsp;&nbsp;</p></td>\n')
put('<td align="left" colspan="4"><p>')
put('<input ' .. disabled_string .. ' type="checkbox" name="std_ringer"')
put(checked_text(ringerCallType[0]))
put(' value="ON">' .. current_dictionary("standard")..'&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="prem_ringer"')
put(checked_text(ringerCallType[1]))
put(' value="ON">' ..current_dictionary("3.1kHz audio").. '&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="udi_ringer"')
put(checked_text(ringerCallType[2]))
put(' value="ON">UDI &nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="rdi_ringer"')
put(checked_text(ringerCallType[3]))
put(' value="ON">RDI</p>')
put('</td></tr>\n')
put('<tr><td>&nbsp</td></tr>')

-- Mute Output
put('<tr><th align="left" colspan="5"><p class="menutext">' .. current_dictionary('mute output') .. '</p></th></tr>\n')
put('<tr>')
put('<td align="left" ><p>' ..current_dictionary("incoming calls").. '&nbsp;&nbsp;</p></td>\n')
put('<td align="left" colspan="4"><p>')
put('<input ' .. disabled_string .. ' type="checkbox" name="std_mute"')
put(checked_text(muteCallType[0]))
put(' value="ON">' .. current_dictionary("standard").. '&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="prem_mute"')
put(checked_text(muteCallType[1]))
put(' value="ON">' ..current_dictionary("3.1kHz audio").. '&nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="udi_mute"')
put(checked_text(muteCallType[2]))
put(' value="ON">UDI &nbsp;&nbsp;')
put('<input ' .. disabled_string .. ' type="checkbox" name="rdi_mute"')
put(checked_text(muteCallType[3]))
put(' value="ON">RDI</p>')
put('</td></tr>\n')
put('<tr><td>&nbsp</td></tr>')

--Submit/Cancel buttons

put('<tr>')
put('<td align="left" colspan="4"><p><input ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
put('&nbsp;&nbsp;<input ' .. disabled_string .. ' type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>')
put('</tr>\n')
put('</table>\n\n')

put('</form>\n')

put(end_of_content)
 