all_mode = false
if cgilua.cgi["ViewAll"] ~= nil then
    if cgilua.cgi["ViewAll"] == "1" then
        --special drafted "text file like" page
        all_mode = true
        require "main"
        require "html"
        put = cgilua.put

        dofile(LUA_WEB_FILE_ROOT .. '/lang.lua')
        cgilua.htmlheader()
        put(start_of_html_page1a)
        put(msg_if.lua_get_long_product_id())
        put(start_of_html_page1b)

        put(start_of_html_page2)
        put('</head><body>')

        idx = 0;
        timeStr, IDStr, severityStr, unitStr, countStr, textStr, listNotEmpty = msg_if.lua_get_first_event_entry(idx, lang, false)
        
        if listNotEmpty then
            put('<table><tr>')
            put('<th align="left"><p>'..current_dictionary("event first reported")..'</p></th>')
            put('<th align="left"><p>&nbsp;'..current_dictionary("event id")..'</p></th>')
            put('<th align="left"><p>&nbsp;'..current_dictionary("event unit")..'</p></th>')
            put('<th align="left"><p>&nbsp;'..current_dictionary("event severity")..'</p></th>')
            put('<th align="left"><p>&nbsp;'..current_dictionary("event text")..'</p></th>')
            put('</tr>')
            while listNotEmpty do
                put('<tr>')
                put('<td align="left"><p>'..translate_month_and_1970(timeStr)..'</p></td>')
                put('<td align="left"><p>&nbsp;'..IDStr..'</p></td>')
                put('<td align="left"><p>&nbsp;'..unitStr..'</p></td>')
                put('<td align="left"><p>&nbsp;'..severityStr..'</p></td>')
                put('<td align="left"><p>&nbsp;'..textStr..'</p></td>')
                put('</tr>')
                idx = idx +1
                timeStr, IDStr, severityStr, unitStr, countStr, textStr, listNotEmpty = msg_if.lua_get_next_event_entry(idx, string.lower(lang), activeEventsOnly)
            end 
        end
            
        put('</body></html>')
    end    
end

show_list_header = function()
    put('<tr>')
    put('<th align="left" width="35%"><p>'..current_dictionary("event first reported")..'</p></th>')
    put('<th align="center" width="10%"><p>'..current_dictionary("event id")..'</p></th>')
    put('<th align="center" width="10%"><p>'..current_dictionary("event unit")..'</p></th>')
    put('<th align="center" width="10%"><p>'..current_dictionary("event severity")..'</p></th>')
    put('<th align="left" width="35%"><p>'..current_dictionary("event text")..'</p></th>')
    put('</tr>')
end


show_log_entry = function(timeStr, IDStr, severityStr, unitStr, textStr)
--Then print log entry
    put('<tr>')
    put('<td align="left"><p>' ..translate_month_and_1970(timeStr).. '</p></td>') 
    put('<td align="center"><p>' ..IDStr.. '</p></td>')
    put('<td align="center"><p>' ..unitStr.. '</p></td>')
    put('<td align="center"><p>' ..severityStr.. '</p></td>')
    put('<td align="left"><p>' ..textStr.. '</p></td>')
    put('</tr>')
end

if not all_mode then
    idx = 0;
    cnt = 0;
    activeEventsOnly = true
    if page_title == "Event log" then
        activeEventsOnly = false
    end
    -- page_title == "Event list" shows active events
    
    if not activeEventsOnly then
        cnt = msg_if.lua_get_event_count(activeEventsOnly)
    end
    
    timeStr, IDStr, severityStr, unitStr, countStr, textStr, listNotEmpty = msg_if.lua_get_first_event_entry(idx, string.lower(lang), activeEventsOnly)
    
    -- Generate the HTML
    put(start_of_content)
    --Print any error message
    put('<table align="center"><tr><td><p id="errortext">')
    put(error_msg .. '</p></td></tr></table>')
    
    put('<table align="left" border="'..border_on..'" cellpadding="1" width="85%">')
    put('<form method="post" action="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. ' ">')
    
    if listNotEmpty then
        if not activeEventsOnly then
            cnt = msg_if.lua_get_event_count(activeEventsOnly)
            if cnt > 30 then
                put('<p>'..current_dictionary("event list too long")..'&nbsp;&nbsp;')
                put('<A HREF="eventlist.lua?langID=' .. lang .. '&amp;ViewAll=1" >' .. current_dictionary("view all events") ..  '</A>')
                put('</p>')
                while listNotEmpty and cnt>30 do
                    timeStr, IDStr, severityStr, unitStr, countStr, textStr, listNotEmpty = msg_if.lua_get_next_event_entry(idx, string.lower(lang), activeEventsOnly)
                    cnt=cnt-1
                end            
            end
        end
        
        show_list_header()
    
        while listNotEmpty do
            show_log_entry(timeStr, IDStr, severityStr, unitStr, textStr)
            idx = idx +1 -- get next event
            timeStr, IDStr, severityStr, unitStr, countStr, textStr, listNotEmpty = msg_if.lua_get_next_event_entry(idx, string.lower(lang), activeEventsOnly)
        end 
        
    else
        put('<th align="left" width="20%"><p>' .. current_dictionary("event list empty") .. '</p></th>')
    end
    put('</form>')
    put('</table>')
    
    put(end_of_content)
end
