if admin_status < 0 then
    error_msg = current_dictionary("enter password")
end

put(start_of_content)
if admin_status < 0 then
    put('<p><table align=left border="'..border_on..'" cellpadding="0">\n')
    put('<form name="adm_password" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
    put('<tr>\n')
        put('<td align="left"  colspan="3"><p id="errortext">' .. error_msg .. '</p></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<th align="left"><p class="menutext">' .. current_dictionary("administrator logon") .. '</p></th>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' .. current_dictionary("username") .. ':</td>\n')
        put('<td align="left"><input type="text" name="usernameAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' ..current_dictionary("password") .. ':</td>\n')
        put('<td align="left"><input type="password" name="passwordAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p><INPUT type="submit" value="' .. current_dictionary("logon") .. '">&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>\n')
    put('</form>\n')
    put('</table></p>\n')
else



-- ***************
-- local functions
-- ***************
show_locked_device = function(ix, ip1, ip2, ip3, ip4, mac)
    put('<tr>')
        put('<td align="left"><p>' ..ip1..'.'..ip2..'.'..ip3..'.'..ip4.. '</p></td>') 
        put('<td align="left"><p>' ..mac.. '</p></td>') 
        put('<td align="left"></td>') 
        put('<td align="center"><p><A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;oper=deleteLock&amp;idx=' .. ix ..'">' .. current_dictionary("delete") .. '</a></p></td>')   
    put('</tr>')
end

show_network_device = function(ix, ip1, ip2, ip3, ip4, mac, name, is_locked)
    put('<tr>')
        put('<td align="left"><p>' ..ip1..'.'..ip2..'.'..ip3..'.'..ip4.. '</p></td>') 
        put('<td align="left"><p>' ..mac.. '</p></td>') 
        put('<td align="left"><p>' ..name.. '</p></td>') 
        if not is_locked then
            page_str = ""
            if pageNo ~= 1 then
                page_str = "&amp;PageNo="..pageNo
            end
            put('<td align="center"><p><A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;oper=lock&amp;mac=' .. mac ..'&amp;ip1='..ip1..'&amp;ip2='..ip2..'&amp;ip3='..ip3..'&amp;ip4='..ip4..page_str..'">' .. current_dictionary("lock ip to mac address") .. '</a></p></td>')   
        end
    put('</tr>')
end

isLocked = function(ip1, ip2, ip3, ip4, mac)
    for i, data in ipairs(locked_device_table) do
        if data[ip1_idx] ~= 0 or data[ip2_idx] ~= 0 or data[ip3_idx] ~= 0 or data[ip4_idx] ~= 0 then
            if data[ip1_idx] == ip1 and data[ip2_idx] == ip2 and data[ip3_idx] == ip3 and data[ip4_idx] == ip4 and data[mac_idx] == mac then
                return true
            end
        end
    end
    return false
end


-- ********************
-- Initiate static data
-- ********************


if cgilua.cgi["oper"] ~= nil then
    if cgilua.cgi["oper"] == "lock" then
        --write entry to lock list
        if cgilua.cgi["mac"] ~= nil and cgilua.cgi["ip1"] ~= nil and cgilua.cgi["ip2"] ~= nil
            and cgilua.cgi["ip3"] ~= nil and cgilua.cgi["ip4"] ~= nil then
            if (not nm_if.lua_write_locked_list_entry(-1,string.gsub(cgilua.cgi["mac"], ":", ""),cgilua.cgi["ip1"],cgilua.cgi["ip2"],cgilua.cgi["ip3"],cgilua.cgi["ip4"])) then
                error_msg = current_dictionary("max locked addresses exceeded")
                pageNo = 1
            end    
        end
    elseif cgilua.cgi["oper"] == "deleteLock" then
        if cgilua.cgi["idx"] ~= nil then
            if (nm_if.lua_write_locked_list_entry(tonumber(cgilua.cgi["idx"])-1,"",0,0,0,0)) then
            end
        end
    end
end


-- *****************
-- get current state
-- *****************
num_locked_devices = 0
locked_device_table = {}
num_devices = 0
device_table = {}

mac_idx = 1
ip1_idx = 2
ip2_idx = 3
ip3_idx = 4
ip4_idx = 5
name_idx = 6


num_locked_devices, total_num_locked = nm_if.lua_get_locked_list_cnt()
for i = 0, total_num_locked-1 do
    mac, ip_addr1, ip_addr2, ip_addr3, ip_addr4 = nm_if.lua_get_locked_list_entry(i)
    table.insert(locked_device_table, {mac, ip_addr1, ip_addr2, ip_addr3, ip_addr4})
end
--nm_if.lua_rel_locked_list()
-- TODO remove
for i, data in ipairs(locked_device_table) do
    trace(0, 1, string.format("%d: %s %d.%d.%d.%d",i,data[1],data[2],data[3],data[4],data[5]))
end


num_devices = nm_if.lua_get_device_list_cnt()
for i = 0, num_devices-1 do
    mac, ip_addr1, ip_addr2, ip_addr3, ip_addr4, name = nm_if.lua_get_device_list_entry(i)
    table.insert(device_table, {mac, ip_addr1, ip_addr2, ip_addr3, ip_addr4, name})
end
nm_if.lua_rel_device_list()
-- TODO remove
for i, data in ipairs(device_table) do
    trace(0, 1, string.format("%d: %s %d.%d.%d.%d %s",i,data[1],data[2],data[3],data[4],data[5],data[6]))
end

-- add sort handling here
sort=""

-- pageNumber
if cgilua.cgi["PageNo"] ~= nil then
    pageNo = tonumber(cgilua.cgi["PageNo"])
else
    pageNo = 1 
end    


--Find number of pages
entriesPerPage = 20
rem = math.mod(num_devices, entriesPerPage) 
nPages = (num_devices - rem)/entriesPerPage
if rem > 0 then
   nPages = nPages + 1
end    

-- TODO
-- check access permission
disabled_string = ''
allowed = true
if admin_status < 0 then
    allowed = msg_if.lua_get_user_permissions("change_lan")
    if not allowed then 
        disabled_string = ' disabled '
        error_msg = current_dictionary("admin_locked")
    end
end

put('<p id="errortext">' .. error_msg .. '</p>')
put('<p><table border="'..border_on..'" cellpadding="0" align="left" valign="top" width="85%">')

put('<form name="devices_form" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')

if pageNo == 1 then
    put('<tr>')
        put('<th align="left" colspan="4"><p class="menutext">' ..current_dictionary("locked ip addresses") .. '&nbsp;</p></th>\n') 
    put('</tr>')
    put('<tr>')
        put('<th align="left"><p>' ..current_dictionary("ip address") .. '</p></th>')
        put('<th align="left"><p>' ..current_dictionary("mac address") .. '</p></th>') 
    put('</tr>')

    for i, data in ipairs(locked_device_table) do
        if data[ip1_idx] ~= 0 or data[ip2_idx] ~= 0 or data[ip3_idx] ~= 0 or data[ip4_idx] ~= 0 then
            show_locked_device(i, data[ip1_idx],data[ip2_idx],data[ip3_idx],data[ip4_idx], data[mac_idx])
        end
    end
    put('<tr><td>&nbsp;</td></tr>')
end

put('<tr>')
    put('<th align="left" colspan="4"><p class="menutext">' ..current_dictionary("network devices") .. '&nbsp;</p></th>\n') 
put('</tr>')
put('<tr>')
    put('<th align="left" width="15%"><p>' ..current_dictionary("ip address") .. '</p></th>')
    put('<th align="left" width="22%"><p>' ..current_dictionary("mac address") .. '</p></th>') 
    put('<th align="left" width="24%"><p>' ..current_dictionary("device name") .. '</p></th>\n') 
    put('<th align="left"></th>\n') 
put('</tr>')

-- Calculate entry startIx and stopIx for the page to be shown
startIx = 1 + (pageNo - 1)*entriesPerPage
if pageNo < nPages then
    stopIx = startIx + entriesPerPage - 1
else
    stopIx = num_devices
end

for i = startIx, stopIx do
    show_network_device(i, device_table[i][ip1_idx],device_table[i][ip2_idx],device_table[i][ip3_idx],device_table[i][ip4_idx], device_table[i][mac_idx], device_table[i][name_idx],
        isLocked(device_table[i][ip1_idx],device_table[i][ip2_idx],device_table[i][ip3_idx],device_table[i][ip4_idx], device_table[i][mac_idx]))
end        
    
if nPages > 1 then
    put('<tr><td colspan="4" align="left">\n')
    put('<p class="menutext">')
        for i = 1, nPages do
            link_generate (page_title, "&amp;PageNo=" ..i.. sort,  i, "direct")
            put(" ")
        end    
    put('</p>\n')
    put('</td></tr>') 
end
put('</form>')
put('</table></p>\n')

end
put(end_of_content)


