if admin_status < 0 then
    error_msg = current_dictionary("enter password")
end

put(start_of_content)
if admin_status < 0 then
    put('<p><table align=left border="'..border_on..'" cellpadding="0">\n')
    put('<form name="adm_password" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">\n')
    put('<tr>\n')
        put('<td align="left"  colspan="3"><p id="errortext">' .. error_msg .. '</p></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<th align="left"><p class="menutext">' .. current_dictionary("administrator logon") .. '</p></th>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' .. current_dictionary("username") .. ':</td>\n')
        put('<td align="left"><input type="text" name="usernameAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p>' ..current_dictionary("password") .. ':</td>\n')
        put('<td align="left"><input type="password" name="passwordAdm"></td>\n')
    put('</tr>\n')
    put('<tr>\n')
    put('</tr>\n')
    put('<tr>\n')
        put('<td align="left"><p><INPUT type="submit" value="' .. current_dictionary("logon") .. '">&nbsp;&nbsp;<INPUT type="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
    put('</tr>\n')
    put('</form>\n')
    put('</table></p>\n')
else

show_nug = function(ix, name, enab, conn, auto)
    put('<tr>')
        put('<td align="left"><p>' ..name.. '</p></td>') 
        if enab == TT_TRUE then
            put('<td align="left"><p>' ..current_dictionary("enabled").. '</p></td>') 
        else
            put('<td align="left"><p>' ..current_dictionary("disabled").. '</p></td>') 
        end
        if conn == 0 then
            put('<td align="left"><p>' ..current_dictionary("shared connection").. '</p></td>') 
        elseif conn == 1 then
            put('<td align="left"><p>' ..current_dictionary("direct connection").. '</p></td>') 
        elseif conn == 2 then
            put('<td align="left"><p>' ..current_dictionary("no internet access").. '</p></td>') 
        else
            put('<td align="left"><p>--</p></td>') 
        end
        if auto == TT_TRUE then
            put('<td align="left"><p>' ..current_dictionary("enabled").. '</p></td>') 
        else
            put('<td align="left"><p>' ..current_dictionary("disabled").. '</p></td>') 
        end
        put('<td align="left"><p>')
        put('<A HREF="index.lua?pageID=' .. page_title .. '&amp;langID=' .. lang .. '&amp;oper=edit&amp;idx=' .. ix ..'">' .. current_dictionary("edit") .. '</a>')
        put('</p></td>')   
    put('</tr>')
end


-- ********************
-- Initiate static data
-- ********************
show_edit_page = false
edit_idx = -1

if cgilua.cgi["idx"] ~= nil then
    interface_id = "nug"..tonumber(cgilua.cgi["idx"])

    namestd = profiles_if.get_profile_name(0)
    name32 = profiles_if.get_profile_name(1)
    name64 = profiles_if.get_profile_name(2)
    name128 = profiles_if.get_profile_name(3)
    name1 = profiles_if.get_profile_name(4)
    name2 = profiles_if.get_profile_name(5)
    name3 = profiles_if.get_profile_name(6)
    name256 = profiles_if.get_profile_name(7)
    
    if streaming == "STREAMING_32_256" then
        names = {namestd,name32,name64,name128,name1,name2,name3,name256}
    else
        names = {namestd,name32,name64,name128,name1,name2,name3}
    end
    
    default_apn = msg_if.lua_read_usim_apn("apn",0)
    acl_apn = msg_if.lua_read_usim_apn("acl",0)
    if default_apn == "" then
        default_apn = acl_apn
    end
    
    ip1, ip2, ip3, ip4, get_apn, get_username, get_password = msg_if.lua_get_pdp_context(interface_id)
    
    save_username = get_username
    save_password = get_password
end

if cgilua.cgi["oper"] ~= nil then
    if cgilua.cgi["oper"] == "edit" and cgilua.cgi["idx"] ~= nil then
        show_edit_page = true
        edit_idx = tonumber(cgilua.cgi["idx"])
    end
elseif cgilua.cgi["submit"] ~= nil then
    trace(0, 1, "in submit");

    edit_idx = tonumber(cgilua.cgi["idx"])

    if cgilua.cgi["radio_onoff_autoactivate"] ~= nil then
        if cgilua.cgi["radio_onoff_autoactivate"] == "auto" then
            auto = TT_TRUE
        elseif cgilua.cgi["radio_onoff_autoactivate"] == "manual" then
            auto = TT_FALSE
        end
    end
    if cgilua.cgi["radio_onoff_enabled"] ~= nil then
        if cgilua.cgi["radio_onoff_enabled"] == "enabled" then
            enab = TT_TRUE
        elseif cgilua.cgi["radio_onoff_enabled"] == "disabled" then
            enab = TT_FALSE
        end
    end
    if cgilua.cgi["conn"] ~= nil then
        conn = tonumber(cgilua.cgi["conn"])
    end
    if edit_idx == 10 then
        enab = TT_TRUE
    end
    nm_if.lua_set_nug_config(edit_idx, auto, enab, conn)
    
    if edit_idx ~= 10 then
        nm_if.lua_set_nug_name(edit_idx, cgilua.cgi["grp_name"])
    end

    if cgilua.cgi["usernamePdp"] ~= nil then
        save_username = cgilua.cgi["usernamePdp"]
    end
    if cgilua.cgi["passwordPdp"] ~= nil then
        save_password = cgilua.cgi["passwordPdp"] 
    end

    set_apn = get_apn
    if cgilua.cgi["apn_radio"] ~= nil then
        if cgilua.cgi["apn_radio"] == "V1" then
            common_apn_info = msg_if.lua_get_apn_info("common")
            if common_apn_info == 1 then
                set_apn = default_apn
            elseif common_apn_info == 2 then
                set_apn = ""
            elseif common_apn_info == 3 then
                c1, c2, c3, c4, get_common_apn, get_common_username, get_common_password = msg_if.lua_get_pdp_context("common")
                set_apn = get_common_apn
            end
            msg_if.lua_set_apn_info(interface_id,0)
        elseif cgilua.cgi["apn_radio"] == "V2" then
            set_apn = default_apn
            msg_if.lua_set_apn_info(interface_id,1)
        elseif cgilua.cgi["apn_radio"] == "V3" then
            msg_if.lua_set_apn_info(interface_id,2)
            set_apn = ""
        elseif cgilua.cgi["apn_radio"] == "V4" then
            if cgilua.cgi["apn_text"] ~= nil then
                set_apn = cgilua.cgi["apn_text"]
                msg_if.lua_set_apn_info(interface_id,3)
            end
        end
    end

    if cgilua.cgi["TCPIP"] ~= nil then
        --print("lua - TCPIP not nil")
        if cgilua.cgi["TCPIP"] == "V1" then
            --print("lua - dynamic ip address")
            msg_if.lua_set_pdp_context(interface_id,set_apn,0,0,0,0,save_username,save_password)
        elseif cgilua.cgi["TCPIP"] == "V2" then
            --print("lua - static ip address")
            if cgilua.cgi["IP_ADDR1"] ~= nil and cgilua.cgi["IP_ADDR2"] ~= nil and cgilua.cgi["IP_ADDR3"] ~= nil and cgilua.cgi["IP_ADDR4"] ~= nil 
                and cgilua.cgi["IP_ADDR1"] ~= '' and cgilua.cgi["IP_ADDR2"] ~= '' and cgilua.cgi["IP_ADDR3"] ~= '' and cgilua.cgi["IP_ADDR4"] ~= '' then
                msg_if.lua_set_pdp_context(interface_id,set_apn,cgilua.cgi["IP_ADDR1"],cgilua.cgi["IP_ADDR2"],cgilua.cgi["IP_ADDR3"],cgilua.cgi["IP_ADDR4"],save_username,save_password)    
            else
                error_msg = current_dictionary("please enter a static ip address")
            end  
        end
    end 

    primary_temp = 255
    set_profile = "no"
    if cgilua.cgi["primaryconnectionclass"] ~= nil then
        set_profile = "yes"
        --print("primary_profile: " .. tostring(cgilua.cgi["primaryconnectionclass"]))
        if tostring(cgilua.cgi["primaryconnectionclass"]) == names[1] then
            primary_temp = 0
        elseif tostring(cgilua.cgi["primaryconnectionclass"]) == names[2] then
            primary_temp = 1
        elseif tostring(cgilua.cgi["primaryconnectionclass"]) == names[3] then
            primary_temp = 2
        elseif tostring(cgilua.cgi["primaryconnectionclass"]) == names[4] then
            primary_temp = 3
        elseif tostring(cgilua.cgi["primaryconnectionclass"]) == names[5] then
            primary_temp = 4
        elseif tostring(cgilua.cgi["primaryconnectionclass"]) == names[6] then
            primary_temp = 5
        elseif tostring(cgilua.cgi["primaryconnectionclass"]) == names[7] then
            primary_temp = 6
        elseif tostring(cgilua.cgi["primaryconnectionclass"]) == names[8] then
            primary_temp = 7
        end
        --print("primary_temp: " .. primary_temp)
    end

    sec_temp = {255,255,255,255,255,255,255,255}
    if cgilua.cgi["secondaryconnectionclass"] ~= nil then
        set_profile = "yes"
        --print("secondary_profile: " .. tostring(cgilua.cgi["secondaryconnectionclass"]))
        if type(cgilua.cgi["secondaryconnectionclass"]) == "table" then
            for i = 1,table.getn(cgilua.cgi["secondaryconnectionclass"]) do
                --print("secondary_profile: " .. tostring(cgilua.cgi["secondaryconnectionclass"][i]))
                for j = 1,table.getn(names) do
                    --print("names: " .. names[j])
                    if cgilua.cgi["secondaryconnectionclass"][i] == names[j] then
                        sec_temp[i] = j-1
                    end 
                end
            end
    
        else
            for i = 1,table.getn(names) do
                if tostring(cgilua.cgi["secondaryconnectionclass"]) == names[i] then
                    sec_temp[1] = i-1
                end 
            end
        end
    end

    if set_profile == "yes" then
        msg_if.lua_set_profile_list(interface_id,primary_temp,sec_temp[1],sec_temp[2],sec_temp[3],sec_temp[4],sec_temp[5],sec_temp[6],sec_temp[7],sec_temp[8])
    end


--    if cgilua.cgi["lan_pdp_activate"] ~= nil then
--        msg_if.lua_stop_pdp_all_lan()
--    end

    if cgilua.cgi["radio_onoff_hcomp"] ~= nil then
        if cgilua.cgi["radio_onoff_hcomp"] == "enabled" then
            msg_if.lua_set_header_comp(interface_id,1)
        elseif cgilua.cgi["radio_onoff_hcomp"] == "disabled" then
            msg_if.lua_set_header_comp(interface_id,0)
        end
    end

--    if cgilua.cgi["radio_onoff_dhcp"] ~= nil then
--        if cgilua.cgi["radio_onoff_dhcp"] == "enabled" then
--            msg_if.lua_set_dhcp_status(1)
--        elseif cgilua.cgi["radio_onoff_dhcp"] == "disabled" then
--            msg_if.lua_set_dhcp_status(0)
--        end
--    end

    if error_msg ~= "" then
        show_edit_page = true
        --edit_idx already set
    end
end

-- *****************
-- get current state
-- *****************
num_entries = 0
nug_table = {}

for i = 0, 10 do
    auto_act, enabled, conn_type = nm_if.lua_get_nug_config(i)
    title = nm_if.lua_get_nug_name(i)
    table.insert(nug_table, {name = title, auto = auto_act, enab = enabled, conn = conn_type})
end

if show_edit_page then

    --dhcp_mode = ""
    ip4addr = "0.0.0.0"
    apn = ""
    apn_info = msg_if.lua_get_apn_info(interface_id)
    -- autoactivate_mode = ""
    
    -- dhcp_mode = msg_if.lua_get_dhcp_status()
    -- autoactivate_mode = msg_if.lua_get_pdp_autoactivate()
    ip4addr1, ip4addr2, ip4addr3, ip4addr4, apn, username, password = msg_if.lua_get_pdp_context(interface_id)
    
    pri, sec1, sec2, sec3, sec4, sec5, sec6, sec7, sec8, sec9, sec10 = msg_if.lua_get_profile_list(interface_id)
    sec = {sec1, sec2, sec3, sec4, sec5, sec6, sec7, sec8, sec9, sec10}
    for i = 1,table.getn(sec) do
        --print("secondary_profile(get): " .. tostring(sec[i])) 
    end 
    hcomp_status = msg_if.lua_get_header_comp(interface_id)

end

-- TODO
-- check access permission
disabled_string = ''
allowed = true
if admin_status < 0 then
    allowed = msg_if.lua_get_user_permissions("change_lan")
    if not allowed then 
        disabled_string = ' disabled '
        error_msg = current_dictionary("admin_locked")
    end
end

put('<p id="errortext">' .. error_msg .. '</p>')
put('<p><table border="'..border_on..'" cellpadding="0" align="left" valign="top">')

put('<form name="usergroup_form" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')

if show_edit_page then
    
    put('<th align="left" colspan="3"><p class="menutext">'..current_dictionary("network user group") .. '</p></th>\n') 
    put('<tr>')
        put('<td align="left"><p>'..current_dictionary("name")..'</p></td>')
        if edit_idx ~= 10 then
            put('<td align="left"><p><input '..disabled_string..'type="text" name="grp_name" maxlength="20" size="25" value="'..nug_table[edit_idx+1].name ..'"></p></td>')
        else
            put('<td align="left"><p>'..nug_table[edit_idx+1].name ..'</p></td>')
        end
    put('</tr>\n')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("status") .. '</p></td>')
        if edit_idx ~= 10 then
            put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" name="radio_onoff_enabled" value="enabled" ' ..checked_text(nug_table[edit_idx+1].enab == TT_TRUE).. '>' .. current_dictionary("enabled"))
            put('&nbsp;<input  ' .. disabled_string .. ' type="radio" name="radio_onoff_enabled" value="disabled" ' ..checked_text(nug_table[edit_idx+1].enab == TT_FALSE).. '>' .. current_dictionary("disabled") .. '</p></td>\n')             
        else
            put('<td align="left"><p>' .. current_dictionary("enabled")..'</p></td>\n')             
        end
    put('</tr>')                    
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("connection type") .. '</p></td>')
        put('<td align="left"><select '..disabled_string..' size="1" name="conn">\n')
        put('    <option ' ..selected_text(nug_table[edit_idx+1].conn == 0).. 'value="0">'.. current_dictionary("shared connection") ..'</option>\n')
        if edit_idx ~= 10 then
            put('    <option ' ..selected_text(nug_table[edit_idx+1].conn == 1).. 'value="1">'.. current_dictionary("direct connection") ..'</option>\n')
        end            
        put('    <option ' ..selected_text(nug_table[edit_idx+1].conn == 2).. 'value="2">'.. current_dictionary("no internet access") ..'</option>\n')
        put('</select></td>')
    put('</tr>')                    
    
    put('<tr>')
        put('<td align="left" colspan="2"><p id="errortext">'..current_dictionary("changes to parms requires reboot")..'</p></td>')
    put('</tr>')                    

    put('<tr>')
        put('<th align="left"><p class="menutext">TCP/IP</p></th>\n')
    put('</tr>')

    if ip4addr1 == 0 and ip4addr2 == 0 and ip4addr3 == 0 and ip4addr4 == 0 then
        dynamic= 0
    else
        dynamic= 1
    end
    put('<tr>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" value="V1" name="TCPIP"' ..checked_text(dynamic == 0).. '>' ..current_dictionary("dynamic ip address").. '</p></td>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" name="TCPIP" value="V2"' ..checked_text(dynamic == 1).. '>' ..current_dictionary("static ip address").. '</p></td>')
        if dynamic == 0 then
            put('<td align="left" colspan="2"><p><input  ' .. disabled_string .. ' type="text" maxlength="3" name="IP_ADDR1" size="3">.<input  ' .. disabled_string .. ' type="text" maxlength="3" name="IP_ADDR2" size="3">.<input  ' .. disabled_string .. ' type="text" maxlength="3" name="IP_ADDR3" size="3">.<input  ' .. disabled_string .. ' type="text" maxlength="3" name="IP_ADDR4" size="3"></p></td>\n')
        else
            put('<td align="left" colspan="2"><p><input  ' .. disabled_string .. ' type="text" maxlength="3" name="IP_ADDR1" size="3" value=' .. ip4addr1 .. '>.<input  ' .. disabled_string .. ' type="text" maxlength="3" name="IP_ADDR2" size="3" value=' .. ip4addr2 .. '>.<input  ' .. disabled_string .. ' type="text" maxlength="3" name="IP_ADDR3" size="3" value=' .. ip4addr3 .. '>.<input  ' .. disabled_string .. ' type="text" maxlength="3" name="IP_ADDR4" size="3" value=' .. ip4addr4 .. '></p>\n')
        end
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("ip header compression") .. '</p></td>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" name="radio_onoff_hcomp" value="enabled" ' ..checked_text(hcomp_status == 1).. '>' .. current_dictionary("enabled"))
        put('&nbsp;<input  ' .. disabled_string .. ' type="radio" name="radio_onoff_hcomp" value="disabled" ' ..checked_text(hcomp_status == 0).. '>'.. current_dictionary("disabled") .. '</p></td>\n')
    put('</tr>')


    put('<tr>') 
        put('<th align="left"><p class="menutext">' ..current_dictionary("apn").. '</p></th>\n') 
    put('</tr>')
    put('<tr>')                
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" value="V1" name="apn_radio" ' ..checked_text(apn_info == 0).. '>' ..current_dictionary("common").. '</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" name="apn_radio" value="V2" ' ..checked_text(apn_info == 1).. '>' ..current_dictionary("sim default").. '</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" name="apn_radio" value="V3" ' ..checked_text(apn_info == 2).. '>' ..current_dictionary("network assigned").. '</p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" name="apn_radio" value="V4" ' ..checked_text(apn_info == 3).. '>' ..current_dictionary("user defined").. '</p></td>\n')
        put('<td align="left" colspan="2"><p><input  ' .. disabled_string .. ' type="text" name="apn_text" size="28" value="' .. apn ..'"></p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("username").. '</p></td>')
        put('<td align="left" colspan="2"><p><input  ' .. disabled_string .. ' type="text" name="usernamePdp" value="' .. save_username ..'"></p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("password").. '</p></td>')
        put('<td align="left" colspan="2"><p><input  ' .. disabled_string .. ' type="password" name="passwordPdp" value="' .. save_password .. '"></p></td>\n')
    put('</tr>')
    put('<tr>')
        put('<th align="left" valign="top"><p class="menutext">' ..current_dictionary("profiles").. '</p></th>')
    put('</tr>')
    put('<tr>')
        put('<td align="left"><p>' ..current_dictionary("automatic activation") .. '</p></td>')
        put('<td align="left"><p><input  ' .. disabled_string .. ' type="radio" name="radio_onoff_autoactivate" value="auto" ' ..checked_text(nug_table[edit_idx+1].auto == TT_TRUE).. '>' .. current_dictionary("enabled"))
        put('&nbsp;<input  ' .. disabled_string .. ' type="radio" name="radio_onoff_autoactivate" value="manual" ' ..checked_text(nug_table[edit_idx+1].auto == TT_FALSE).. '>' .. current_dictionary("disabled") .. '</p></td>\n')             
    put('</tr>')                    

    put('<tr>')
        put('<td align="left" valign="top" ><p>' ..current_dictionary("primary") .. '</p></td>')
        put('<td align="left"><select  ' .. disabled_string .. ' size="7" name="primaryconnectionclass">')
        put('    <option ' ..selected_text(pri == 0).. '>' ..names[1].. '</option>\n')
        put('    <option ' ..selected_text(pri == 1).. '>' ..names[2].. '</option>\n')
        put('    <option ' ..selected_text(pri == 2).. '>' ..names[3].. '</option>\n')
        if streaming ~= "STREAMING_32_64" then
            put('    <option ' ..selected_text(pri == 3).. '>' ..names[4].. '</option>\n')
        end
        if streaming == "STREAMING_32_256" then
            put('    <option ' ..selected_text(pri == 7).. '>' ..names[8].. '</option>\n')
        end
        put('    <option ' ..selected_text(pri == 4).. '>' .. names[5] .. '</option>\n')
        put('    <option ' ..selected_text(pri == 5).. '>' .. names[6] .. '</option>\n')
        if streaming ~= "STREAMING_32_256" then
            put('    <option ' ..selected_text(pri == 6).. '>' .. names[7] .. '</option>\n')
        end
        put('  </select></td>\n')
    put('</tr>')
    put('<tr>')
        put('<td align="left" valign="top"><p>' ..current_dictionary("secondary") .. '</p></td>')
        put('<td align="left"><select  ' .. disabled_string .. ' size="7" name="secondaryconnectionclass" multiple>\n')
        not_selected = "true"
        --streaming 32,64,128
        for i = 1,4 do
            if streaming == "STREAMING_32_64" and i == 4 then 
                break   
            end
            for j = 1,table.getn(sec) do
                if sec[j]+1 == i then
                    not_selected = "false"
                end
            end
            if not_selected == "false" then
                not_selected = "true"
                put('    <option selected>' .. names[i] .. '</option>\n')
            else
                not_selected = "true"
                put('    <option>' .. names[i] .. '</option>\n')
            end
        end
        --streaming 256
        if streaming == "STREAMING_32_256" then
            for j = 1,table.getn(sec) do
                if sec[j]+1 == 8 then
                    not_selected = "false"
                end
            end
            if not_selected == "false" then
                not_selected = "true"
                put('    <option selected>' .. names[8] .. '</option>\n')
            else
                not_selected = "true"
                put('    <option>' .. names[8] .. '</option>\n')
            end
        end
        --user defined
        for i = 5,7 do
            if streaming == "STREAMING_32_256" and i == 7 then 
                 break
            end
            for j = 1,table.getn(sec) do
                if sec[j]+1 == i then
                    not_selected = "false"
                end
            end
            if not_selected == "false" then
                not_selected = "true"
                put('    <option selected>' .. names[i] .. '</option>\n')
            else
                not_selected = "true"
                put('    <option>' .. names[i] .. '</option>\n')
            end
        end
        put('</select></td>')
    put('</tr>')

    pri, sec1, sec2, sec3, sec4, sec5, sec6, sec7, sec8, sec9, sec10 = msg_if.lua_get_profile_list(interface_id)
    cids = {pri, sec1, sec2, sec3, sec4, sec5, sec6, sec7, sec8, sec9, sec10}
    put('<tr>')
        put('<th align="left" colspan="2"><p class="menutext">' ..current_dictionary("profile cids").. '&nbsp;</p></th>')
    put('</tr>')
    put('<tr>')
        put('<th align="left"><p>' ..current_dictionary("profile").. '</p></th>')
        put('<th align="left"><p>Cid</p></th>')
    put('</tr>')
    for j = 1,table.getn(cids) do
        --print('cid[' .. j .. ']: ' .. cids[j]) 
        if cids[j] ~= 255 then
            temp_cid = cids[j]+1
            if j == 1 then
                put('<tr><p><td align="left"><p>' .. names[temp_cid] .. '</p></td><td><p>' .. 1 .. '</p></td></tr>')                
            else
                put('<tr><p><td align="left"><p>' .. names[temp_cid] .. '</p></td><td><p>' .. temp_cid+1 .. '</p></td></tr>')                
            end
        end
    end

    --submit button
    put('<tr>')
    put('<td align="left"><p><input  ' .. disabled_string .. ' type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
        put('&nbsp;&nbsp;<input  ' .. disabled_string .. ' type="submit" name="submit_back" value="' .. current_dictionary("cancel") .. '"></p>')
        put('<input type="hidden" name="idx" value="'..edit_idx..'"></td>\n')
    put('</tr>')
--    if autoactivate_mode == 1 then 
--        -- In auto activate mode we give user an option to reactivate the auto-activated context
--        put('<tr><td></td><td>&nbsp;&nbsp;</td></tr>')
--        put('<tr><td></td><td>&nbsp;&nbsp;</td></tr>')
--        put('<tr><td colspan="2" align="left"><p id="errortext">' ..current_dictionary("lan pdp explain").. '</p></td></tr>')
--        put('<tr><td><p><input  ' .. disabled_string .. ' type="submit" name="lan_pdp_activate" value="' .. current_dictionary("activate") .. '"></p>')
--        put('</td>')
--        put('</tr>')
--    end


else
    put('<tr>')
        put('<th align="left" colspan="4"><p class="menutext">' ..current_dictionary("network user groups") .. '&nbsp;</p></th>\n') 
    put('</tr>')
    put('<tr>')
        put('<th align="left" width="20%"><p>' ..current_dictionary("name") .. '</p></th>') 
        put('<th align="left" width="15%"><p>' ..current_dictionary("status") .. '</p></th>')
        put('<th align="left" width="20%"><p>' ..current_dictionary("connection type") .. '</p></th>')
        put('<th align="left" width="15%"><p>' ..current_dictionary("automatic activation") .. '</p></th>')
    put('</tr>')
    
    for i, data in ipairs(nug_table) do
        show_nug(i-1, data.name, data.enab, data.conn, data.auto)
    end
    
end
put('</form>')
put('</table></p>\n')

end
put(end_of_content)



