local function batmon_status()
    local myq=Queue.lookup("xavante")
    local q=Queue.lookup("batmon")

    local message_table=
    {
        ["head"] = {
            ["messageId"] = "BATMON_MESSAGE_ID_SHORT_STATUS_REQ",
            ["returnQueue"] = myq,
            ["returnMessageId"] = "BATMON_MESSAGE_ID_SHORT_STATUS_RSP"
        }
    }
    local message=msg_if.to_std_msg(message_table)
    q:put(message)
    return_message = myq:get(50000)
    if not return_message then
        return "batmon status: unknown"
    end
    return_message_table = msg_if.from_batmon_msg(return_message)
    return return_message_table
end

msg_if.read_config_db_ip_addr()
status, capacity = msg_if.lua_battery_status()

put(battery_status_start)
if product ~= "EBDU" and product ~= "E727" and product ~= "E723" and product ~= "SBDU" and product ~= "S500" and product ~= "S250" and product ~= "SBL" then
    put(current_dictionary("battery") .. ":")
end
put(battery_status_end1)

    if status == 2 then
        put('batteryanimation.gif alt="Charging battery"')
    elseif status == 1 then  
        if capacity > 95 then
            put('battery100.gif')
        elseif capacity  > 85  then
            put('battery90.gif')
        elseif capacity  > 75  then
            put('battery80.gif')
        elseif capacity  > 65  then
            put('battery70.gif')
        elseif capacity  > 55  then
            put('battery60.gif')
        elseif capacity  > 45  then
            put('battery50.gif')
        elseif capacity  > 35  then
            put('battery40.gif')
        elseif capacity  > 25  then
            put('battery30.gif')
        elseif capacity  > 15  then
            put('battery20.gif')
        elseif capacity  > 5  then
            put('battery10.gif')
        else 
            put('battery00.gif')
        end
        put(' alt="Battery capacity: ' .. capacity .. '"') 
    else
        put('batteryfill.gif alt="No battery"')
    end 

put(battery_status_end2)
put(signal_status_start)
put(current_dictionary("signal") .. ":")
put(signal_status_end1)
cn0 = msg_if.lua_get_cn0()
cn0_show = cn0
-- normalize cn0 value to e500 range
if product == "E700" then
    cn0 = cn0 - 25
end
        if cn0 > 650 then
            put('signal7.gif')
        elseif cn0  > 600  then
            put('signal6.gif')
        elseif cn0  > 550  then
            put('signal5.gif')
        elseif cn0  > 500  then
            put('signal4.gif')
        elseif cn0  > 450  then
            put('signal3.gif')
        elseif cn0  > 400  then
            put('signal2.gif')
        elseif cn0  > 350  then
            put('signal1.gif')
        else 
            put('signal0.gif')
        end
        put(' alt="Signal strength: ' .. cn0_show/10 .. '"')
put(signal_status_end2)
