-- Function declarations

checked_text = function (chk)
  if (chk == string.byte('1')) then
    return ' checked '
  else
    return ''
  end
end

--Function to insert row of boxes
put_boxes = function (n, name_of_line)
    put('<tr>')
    put('<th align="left" width="87"><p>' ..name_of_line.. '</p></th>')
    if streaming == "STREAMING_32_64" then
        put('<td align="center" width="68"><input type="checkbox" name="' .. name_arr[n]   ..'" value="ON"' .. checked_text(string.byte(Checked_new, n))     .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+1] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 1)) .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+2] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 2)) .. '></td>')
        put('<td align="center" width="54"><input type="checkbox" name="' .. name_arr[n+3] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 3)) .. '></td>')
        put('<td align="center" width="54"><input type="checkbox" name="' .. name_arr[n+4] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 4)) .. '></td>')
        put('<td align="center" width="54"><input type="checkbox" name="' .. name_arr[n+5] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 5)) .. '></td>')
    end
    if streaming == "STREAMING_32_128" then
        put('<td align="center" width="68"><input type="checkbox" name="' .. name_arr[n]   ..'" value="ON"' .. checked_text(string.byte(Checked_new, n))     .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+1] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 1)) .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+2] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 2)) .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+3] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 3)) .. '></td>')
        put('<td align="center" width="54"><input type="checkbox" name="' .. name_arr[n+4] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 4)) .. '></td>')
        put('<td align="center" width="54"><input type="checkbox" name="' .. name_arr[n+5] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 5)) .. '></td>')
        put('<td align="center" width="54"><input type="checkbox" name="' .. name_arr[n+6] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 6)) .. '></td>')
    end
    if streaming == "STREAMING_32_256" then
        put('<td align="center" width="68"><input type="checkbox" name="' .. name_arr[n]   ..'" value="ON"' .. checked_text(string.byte(Checked_new, n))     .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+1] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 1)) .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+2] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 2)) .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+3] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 3)) .. '></td>')
        put('<td align="center" width="74"><input type="checkbox" name="' .. name_arr[n+4] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 4)) .. '></td>')
        put('<td align="center" width="54"><input type="checkbox" name="' .. name_arr[n+5] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 5)) .. '></td>')
        put('<td align="center" width="54"><input type="checkbox" name="' .. name_arr[n+6] ..'" value="ON"' .. checked_text(string.byte(Checked_new, n + 6)) .. '></td>')
    end    put('</tr>')
end


-- Parse incoming parameters
n_box_rows, n_box_cols, Checked_old = tft_if.get_tft() 
n_boxes = n_box_rows*n_box_cols

name_arr = {}
for i = 1, n_boxes do
    name_arr[i] = string.format("%d", i)
end    

if cgilua.cgi["submit"] ~= nil then
    submit_pressed = true
else    
    submit_pressed = false
end    

Checked_new = ""
if submit_pressed then
    for i = 1, n_boxes do
        if cgilua.cgi[name_arr[i]] ~= nil then
            Checked_new = Checked_new..'1'
        else    
            Checked_new = Checked_new..'0'
        end    
    end        
else
    Checked_new = Checked_old
end

error_msg = tft_if.set_tft(Checked_new)
n_box_rows, n_box_cols, Checked_new = tft_if.get_tft() 


text_std = profiles_if.get_profile_name(0)
text_32  = profiles_if.get_profile_name(1)
text_64  = profiles_if.get_profile_name(2)
text_128 = profiles_if.get_profile_name(3)
text_1   = profiles_if.get_profile_name(4)
text_2   = profiles_if.get_profile_name(5)
text_3   = profiles_if.get_profile_name(6)
text_256 = profiles_if.get_profile_name(7)


--Generate html code
put(start_of_content)

if error_msg ~= "" then
    put('<table align=center><tr><td><p id="errortext">')
    put(current_dictionary(error_msg) .. '</p></td></tr></table>') 
end    
put('<table align=center><tr><td><p>')
put(debug_msg .. '</p></td></tr></table>')

--put('<table align=center>\n')
--put('<tr><td>')
--put('<p class="menutext">Traffic Flow Templates</p>')
--put('</td></tr>')
--put('</table>')

put('<table align=center border="'..border_on..'" cellpadding="6" width="759">')
put('<tr><td>')
put('<form name="tft_settings" method="post" action="index.lua?pageID=' .. page_title .. '&langID=' .. lang .. '">')

  put('<tr>')
    put('<td width="87"></td>')
    put('<th align="center" width="68"><p>' ..text_std.. '</p></th>')
    put('<th align="center" width="74"><p>' ..text_32.. '</p></th>')
    put('<th align="center" width="74"><p>' ..text_64.. '</p></th>')
    if streaming ~= "STREAMING_32_64" then
        put('<th align="center" width="74"><p>' ..text_128.. '</p></th>')
    end
    if streaming == "STREAMING_32_256" then
        put('<th align="center" width="74"><p>' ..text_256.. '</p></th>')
    end
    put('<th align="center" width="54"><p>' ..text_1.. '</p></th>')
    put('<th align="center" width="54"><p>' ..text_2.. '</p></th>')
    if streaming ~= "STREAMING_32_256" then
        put('<th align="center" width="54"><p>' ..text_3.. '</p></th>')
    end
  put('</tr>')

    put_boxes(1,        current_dictionary("filter") .. ' 1')
    put_boxes(1 + 1*n_box_cols,  current_dictionary("filter") .. ' 2')
    put_boxes(1 + 2*n_box_cols,  current_dictionary("filter") .. ' 3')
    put_boxes(1 + 3*n_box_cols,  current_dictionary("filter") .. ' 4')
    put_boxes(1 + 4*n_box_cols,  current_dictionary("filter") .. ' 5')
    put_boxes(1 + 5*n_box_cols,  current_dictionary("filter") .. ' 6')
    put_boxes(1 + 6*n_box_cols,  current_dictionary("filter") .. ' 7')
    put_boxes(1 + 7*n_box_cols,  current_dictionary("filter") .. ' 8')
    put_boxes(1 + 8*n_box_cols,  current_dictionary("filter") .. ' 9')
    put_boxes(1 + 9*n_box_cols,  current_dictionary("filter") .. ' 10')
    put_boxes(1 + 10*n_box_cols, current_dictionary("filter") .. ' 11')
    put_boxes(1 + 11*n_box_cols, current_dictionary("filter") .. ' 12')
    put_boxes(1 + 12*n_box_cols, current_dictionary("filter") .. ' 13')
    put_boxes(1 + 13*n_box_cols, current_dictionary("filter") .. ' 14')
    put_boxes(1 + 14*n_box_cols, current_dictionary("filter") .. ' 15')
    put_boxes(1 + 15*n_box_cols, current_dictionary("filter") .. ' 16')
    put_boxes(1 + 16*n_box_cols, current_dictionary("filter") .. ' 17')
    put_boxes(1 + 17*n_box_cols, current_dictionary("filter") .. ' 18')
    put_boxes(1 + 18*n_box_cols, current_dictionary("filter") .. ' 19')
    put_boxes(1 + 19*n_box_cols, current_dictionary("filter") .. ' 20')

  put('<tr>')
    put('<td align="left" colspan="4"><p><input type="submit" name="submit" value="' .. current_dictionary("apply") .. '">')
    put('&nbsp;&nbsp;<input type="reset" name="reset" value="' .. current_dictionary("cancel") .. '"></p></td>\n')
  put('</tr>')

put('</form>\n') 
put('</td></tr>\n')
put('</table>\n')
put(end_of_content)

---------------------------------------------------------







